#include <bits/extc++.h>
using namespace std;
using namespace __gnu_cxx;
using namespace __gnu_pbds;

#define fast ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define sfor(i, l, r) for (int i = l; i <= r; ++i)
#define bfor(i, r, l) for (int i = r; i >= l; --i)
#define range(a) a.begin(), a.end()
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using vi = vector<int>;
using oset = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

ll BinPow(ll x, ll p, ll mod) {
    if (p == 1)
        return x;
    ll y = BinPow(x, p / 2, mod);
    if (p % 2 == 0)
        return y * y % mod;
    else
        return y * y % mod * x % mod;
}

int main() {
    fast;
    ll n, m;
    cin >> n >> m;
    ll k = min(n, m + 1);
    vector<ll> dp1(k), dp2(k);
    dp1[0] = dp1[1] = 0;
    dp2[0] = dp2[1] = 1;
    sfor(i, 2, k - 1) {
        dp1[i] = dp2[i - 2] * (ll)(i - 1) % m;
        dp2[i] = (dp2[i - 1] * (ll)i + dp1[i]) % m;
    }
    ll f = 1;
    if (n >= m)
        f = 0;
    else {
        sfor(i, 2, n) f = f * (ll)i % m;
    }
    ll x = dp2[k - 1];
    if (n > m) {
        x = BinPow(dp1[k - 1], n / m, m) * dp2[n % m] % m;
    }
    ll ans = f - x;
    if (ans < 0)
        ans += m;
    cout << ans << '\n';
}
