#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
using namespace std;
vector<vector<int>>vec;//graph
vector<int>dist;
vector<bool>visit;
#define pii pair<int,int>
void dfs(int u) {
    visit[u] = true;
    for (auto v : vec[u]) {
        if (!visit[v]) {
            dist[v] = dist[u] + 1;
            dfs(v);
        }
    }
}
int main(){
    int n, m;
    cin >> n >> m;
    vec.resize(n);
    int a, b;
    vector<int>par(n,0);
    vector<int>chi(n,0),chi1(n,0);
    int mos;
    for (int i = 0; i < m; i++) {
        cin >> a >> b;
        a--, b--;
        vec[a].push_back(b);
        par[a]++;
        chi[b]++;
        chi1[b]++;
    }
    cin >> mos;
    queue<int>sed;
    vector<int>df1;
    for (int i = 0; i < n; i++) {
        if (chi[i] == 0) {
            sed.push(i);
            df1.push_back(i);
        }
    }
    dist.resize(n, 0);
    visit.resize(n, false);
    for (int i = 0; i < df1.size(); i++) {
        dfs(df1[i]);
    }
    vector<pii>topo;
    while (!sed.empty()) {
        int u = sed.front();
        topo.push_back({ dist[u],u });
        sed.pop();
        for (auto v : vec[u]) {
            chi[v]--;
            if (chi[v] == 0)
                sed.push(v);
        }
    }
    int h = topo[n - 1].first;
    vector<int>wl(h + 1, 0);//w_lines
    vector<int>wls(h + 1, 0);
    for (int i = 0; i < n; i++) {
        wl[topo[i].first] += max(chi1[topo[i].second], par[topo[i].second]);
        wls[topo[i].first]++;
    }
    int w = 0;
    for (int i = 0; i < (h + 1); i++)
        w = max(w, wl[i]);
    cout << h + 1 << " " << w << endl;
    for (int i = 0; i < n; i++) {
        if (i == 0)
            cout << wls[0] << " ";
        else if (topo[i - 1].first != topo[i].first) {
            cout << endl << wls[topo[i].first] << " ";
        }
        cout << topo[i].second+1 << " " << max(chi1[topo[i].second], par[topo[i].second]) << " ";
    }
}