#include <bits/stdc++.h>
using namespace std;

const int NMAX = 2e5 + 1;

vector<int> edges[NMAX];
int indegree[NMAX], outdegree[NMAX], latime[NMAX];
vector<int> nivel[NMAX];
bool sus[NMAX], jos[NMAX], viz[NMAX];
int hmin, wmin, w;
void dfs(int node, int h) {
    int nr = 0;
    nivel[h].push_back(node);
    //cout << "h = " << h << " node = " << node << endl;
    if(sus[node] != 1) {
        //h++;
        for(auto it: edges[node]) {
            latime[it]+=latime[node];
            nr++;
            //cout << "node = " << node << " it = " << it << endl;
            //cout << "latime[node] = " << latime[node] << " latime[it] = " << latime[it] << endl;
            dfs(it, h + 1);
        }
        latime[node] = nr;
    } else {
        hmin = max(hmin, h);
    }
}

int main() {
    int n, m, i;
    cin >> n >> m;
    //cout << "m = " << m << endl;
    for(i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        //edges[a].push_back(b);
        edges[b].push_back(a);
        outdegree[b]++;
        indegree[a]++;
    }
    for(i = 1; i <= n; i++)
        sort(edges[i].begin(), edges[i].end());
    int useless;
    cin >> useless;
    for(i = 1; i <= n; i++) {
        if(outdegree[i] == 0) { /// nodul e sus
            sus[i] = 1;
        }
        if(indegree[i] == 0) {
            //cout << "nodul " << i << endl;
            jos[i] = 1;
            latime[i] = 1;
            //nivel[0].push_back(i);
            //h = 0;
            dfs(i, 0);
        }
    }
    wmin = 0;
    //hmin = h;
    for(i = 0; i <= hmin; i++) {
        w = 0;
        // maximul sumelor latime[nivel[i]]
        for(auto it: nivel[i]) {
            w += latime[it];
        }
        wmin = max(wmin, w);
    }
    cout << hmin << ' ' << wmin << endl;
    for(i = hmin; i >= 0; i--) {
        cout << nivel[i].size() << ' ';
        for(auto it: nivel[i]) {
            cout << it << ' ' << latime[it] << ' ';
        }
        cout << endl;
    }
    return 0;
}
