#include <bits/stdc++.h>
#define ll long long
#define DEBUG false

using namespace std;

ll MOD;
ll sqr(ll n) {
    return n*n;
}
ll powow(ll b, ll e) {
    if(e == 0) { return 1; }
    return (((e%2)*(b-1)+1)*(sqr(pow(b,e/2))%MOD))%MOD;
}
ll inverse(ll n) {
    return powow(n, MOD - 2);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    ll n;
    cin >> n >> MOD; n--;
    ll nt = n/MOD;
    ll nm = n%MOD; 
    vector<ll> fact(nm+2); fact[0] = 1; // fact[k] = (n)!/(n-k)!
    for(ll i = 1; i <= nm ; i ++) {
        fact[i] = (fact[i-1]*(nm-i+1))%MOD;
        if(DEBUG) cout << fact[i] << " ";
    }
    if(DEBUG) cout << endl;

    ll total = 0;
    ll co = (n%2)*2-1;
    for(ll k = 0; k < nm; k ++) {
        total = (total + co * (((k+1) * fact[k])%MOD)) % MOD;
        total = (total + MOD) % MOD;
        if(DEBUG) cout << "total -> " << total << " | + " << ((co * ((k+1) * fact[k])) % MOD) << endl;;
        co = -co;
    }

    cout << total << endl;
    return 0;
}