#include <bits/stdc++.h>
#define ll long long

using namespace std;

ll ugly_precomputing[] = {0,0,1,1,1,3,1,2,2,2,2};

ll sqr(ll n) {
    return n*n;
}
ll powow(ll b, ll e) {
    if(e == 0) { return 1; }
    return ((e%2)*(b-1)+1) * sqr(powow(b,e/2));
}

ll solve(ll n) {
    if(n <= 10) {
        return ugly_precomputing[n];
    }
    ll cnt = 1;
    ll sqrtn = sqrt(n-1);
    for(ll i = 2; i <= sqrtn; i ++) {
        // cout << i << " " << ((n-1)%i) << endl;
        if(!((n-1)%i)) {
            cnt ++;
        }
    }
    ll fif = 30;
    ll mfif = min(n,fif);
    for(ll k = 1; k <= mfif; k ++) {
        if(!((n-k-1)%powow(3,k))) {
            cnt += solve(n-k-1);
        }
    }
    return cnt;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    ll n;
    cin >> n;
    if(n <= 10) {
        cout << ugly_precomputing[n] << endl;
        return 0;
    }
    cout << solve(n) << endl;
    return 0;
}