#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
using namespace std;

int getPrime(int a) {
    int d=2;
    while (d*d<a && a%d!=0) {
        d++;
    }
    if (a%d==0) {
        return d;
    } else {
        return a;
    }
}

int getNumOfPrimes(int a) {
    int ans=1;
    while (a>1) {
        int d=getPrime(a);
        int s1=0;
        while (a%d==0) {
            a/=d;
            s1++;
        }
        ans*=s1;
    }
    return ans;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    int ans=0;
    for (int i=1;i<=n*5;i++) {
        int h=getNumOfPrimes(i);
        if (min(h,n)+n>i && n<=i) {
            ans++;
        }
    }
    cout << ans << "\n";
}
