#include <iostream>
#include <queue>
#include <algorithm>
#include <set>
#include <unordered_set>


using namespace std;
const int nmax=200005;

vector<int> dag[nmax];
vector<int> g[nmax];
int degree[nmax];
unordered_set<int> inv[nmax];

int outdeg[nmax];
int height[nmax];
int upd[nmax];

static void dfs(int x, int f) {
  if(height[x]!=0)  
    return;
  height[x]=height[f]+1;
  for(auto y:dag[x]) {
    dfs(y,x);
  }
}

struct cmp {
  bool operator()(const int x,const int y)const {
    return degree[x]-degree[y];
  }
};
vector<vector<int> > rez;

int lastpoz[nmax];

int main() {
  int n,m;
  cin >> n >> m;
  for(int i=0,x,y; i<m; i++) {
    cin >> x >> y;
    --x;
    --y;
    dag[x].push_back(y);
    g[x].push_back(y);
    g[y].push_back(x);
    degree[x]++;
    degree[y]++;
    outdeg[y]++;
  }
  int maxx=0;
  for(int i=0; i<n; i++) {
    if(outdeg[i]==0)
      height[i]=0,dfs(i,i);
  }
  vector<int> top;
  for(int i=0; i<n; i++)
    maxx=max(height[i],maxx),top.push_back(i);
  sort(top.begin(),top.end(),[](int a, int b){return height[a]<height[b] || (height[a]==height[b] && a<b);});
  rez.resize(maxx);
  for(int i=0; i<n; i++)
    rez[height[top[i]]-1].push_back(top[i]);
  for(int i=0; i<n; i++) {
    if(height[i]==1 || height[i]==maxx)
      degree[i]++;
  }
  multiset<pair<int,int> > stack;
  for(int i=0; i<rez.size(); i++) {
    stack.insert({degree[rez[i][0]],rez[i][0]});
  }
  int len=0;
  vector<int> elim;
  auto copycaestiprost=rez;
  while(stack.size()) {
    //if(len>=16)
      //break;
    //cout << len << '\n';
    //for(auto x: stack)
      //cout << x.second+1 <<' '<< degree[x.second] << '\t';
    //cout << "\n\n";
    len++;
    if(elim.size())
      elim.erase(elim.begin(),elim.end());
    int best=degree[(*stack.begin()).second];
    while(stack.size() && (*stack.begin()).first==best) {
      lastpoz[(*stack.begin()).second]=len;
      elim.push_back((*stack.begin()).second);
      stack.erase(stack.begin());
    }
    for(auto x:elim) {
      //cout << x << "->";
      for(auto y:g[x]) {
        //cout << y << ' ';
          //for(auto x: stack)
            //cout << x.second+1 <<' '<< degree[x.second] << '\t';
          //cout << "\n\n";
        if(stack.count({degree[y],y})!=0)
          stack.erase(stack.find({degree[y],y})),stack.insert({degree[y]-1,y});
        degree[y]--;
      }
      //cout << '\n';
    }
    for(auto x:elim) {
      rez[height[x]-1].erase(rez[height[x]-1].begin());
      if(rez[height[x]-1].size())
        stack.insert({degree[rez[height[x]-1][0]],rez[height[x]-1][0]});
    }
  }
  cout << maxx << ' ' <<len << '\n';
  for(int i=0; i<copycaestiprost.size(); i++) {
    int last=0;
    cout << copycaestiprost[i].size() <<' ';
    for(int j=0; j<copycaestiprost[i].size(); j++) {
      cout << copycaestiprost[i][j]+1  <<' ' << lastpoz[copycaestiprost[i][j]]-last << ' ';
      last=lastpoz[copycaestiprost[i][j]];
    }
    cout << '\n';
  }
}
