#include<iostream>
#include<math.h>
#include<vector>
using namespace std;

vector<long long> pretty(long long n, long long m) {
	if (n == 1)
	{
		return { 1, 0 };
	}
	vector<long long> smaller = pretty(n - 1, m);
	vector<long long> result;
	result.resize(n);
	result[0] = smaller[0] * (n - 1);
	result[1] = smaller[0] % m;
	for (int i = 1; i < n-1; i++)
	{
		result[i - 1] += smaller[i]*i;
		result[i] += smaller[i] * (n - i - 1);
		result[i + 1] += smaller[i];
	}
	for (int i = 0; i < n; i++)
	{
		result[i] %= m;
	}
	return result;
}

int main() {
	long long n, m, result = 0;
	cin >> n >> m;
	vector<long long> sequences = pretty(n, m);
	for (int i = 1; i < n; i++)
	{
		result += sequences[i];
	}
	result %= m;
	cout << result;
}