#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
ll n, m, h = 0, w = 0;
vector<vector<ll>> graph;
vector<ll> layer;
vector<ll> cnt;
vector<ll> info;
vector<vector<ll>> row;

void dfs(ll v) {
    for (auto e: graph[v]) {
        layer[e] = layer[v] + 1;
        dfs(e);
    }
}

int main() {
    cin >> n >> m;
    cnt.resize(n);
    layer.resize(n);
    graph.resize(n);
    info.resize(n);
    for (int i = 0; i < m; i++) {
        ll a, b;
        cin >> a >> b;
        a--;
        b--;
        cnt[b]++;
        graph[a].emplace_back(b);
    }
    ll tp;
    cin >> tp;
    for (ll i = 0; i < n; i++)
        if (cnt[i] == 0) {
            layer[i] = 1;
            dfs(i);
        }
    for (ll i = 0; i < n; i++) {
        h = max(h, layer[i]);
    }
    row.resize(h + 1);
    for (int i = 0; i < n; i++) {
        row[layer[i]].emplace_back(i);
    }
    for (int i = 1; i <= h; i++)
        sort(row[i].begin(), row[i].end());
    vector<int> res;
    for (int j = h; j >= 1; j--) {
        vector<int> ans;
        int k = 0;
        for (int i = 0; i < row[j].size(); i++) {
            if (j == h) {
                info[row[j][i]] = (max(cnt[row[j][i]], ll(1)));
                res.emplace_back(max(cnt[row[j][i]], ll(1)));
            } else {
                int v = row[j][i];
                if (i == row[i].size() - 1) {
                    ll s = 0;
                    for (int q = 0; q < graph[v].size(); q++) {
                        s += res[graph[v][q]];
                    }
                    info[v] = s;
                    ans.emplace_back(s);
                } else {
                    ll s = 0;
                    for (int q = 0; q < graph[v].size() - 1; q++) {
                        if(res[k] == 0){
                            k++;
                        }
                        s += res[k];
                        k++;
                    }
                    s += 1;
                    res[k] -= 1;
                    info[v] = s;
                    ans.emplace_back(s);
                }
            }
        }
        if (j != h)
            res = ans;
    }
    for (int i = 1; i <= h; i++) {
        ll s = 0;
        for (int j = 0; j < row[i].size(); j++)
            s += info[row[i][j]];
        w = max(w, s);
    }
    for (int i = 1; i <= h; i++) {
        ll s = 0;
        for (int j = 0; j < row[i].size(); j++)
            s += info[row[i][j]];
        if (s < w) {
            info[row[i][row[i].size() - 1]] += w - s;
        }
    }
    cout << h << ' ' << w << "\n";
    for (int i = 1; i <= h; i++) {
        cout << row[i].size() << " ";
        for (int j = 0; j < row[i].size(); j++)
            cout << row[i][j] + 1 << " " << info[row[i][j]] << " ";
        cout << "\n";
    }
    return 0;
}