#include <iostream>
#include <vector>
#include <algorithm>

#define MAX_N 200000

using namespace std;

int nivel[MAX_N], nrChildren[MAX_N], nrParents[MAX_N];
vector <int> child[MAX_N], parent[MAX_N], peNivel[MAX_N + 1];

void dfs( int a, int niv ) {
    int i;

    peNivel[niv].push_back( a );
    nivel[a] = niv;
    for ( i = 0; i < child[a].size(); i++ ) {
        if ( nivel[child[a][i]] == 0 )
            dfs( child[a][i], niv + 1 );
    }
}

int main() {
    int n, m, ord, nrNiv, wMax, w, a, b, i, j;

    cin >> n >> m;
    for ( i = 0; i < m; i++ ) {
        cin >> a >> b;
        child[a].push_back( b );
        nrChildren[a]++;
        parent[b].push_back( a );
        nrParents[b]++;
    }
    cin >> ord;

    for ( i = 1; i <= n; i++ ) {
        if ( nrParents[i] == 0 )
            dfs( i, 1 );
    }

    nrNiv = 0;
    wMax = 0;
    for ( i = 1; i <= n; i++ ) {
        if ( peNivel[i].size() > 0 )
            nrNiv++;
        sort( peNivel[i].begin(), peNivel[i].end() );
        w = 0;
        for ( j = 0; j < peNivel[i].size(); j++ )
            w += max( nrChildren[peNivel[i][j]], nrParents[peNivel[i][j]] );
        if ( w > wMax )
            wMax = w;
    }

    cout << nrNiv << " " << wMax << "\n";
    for ( i = 1; i <= nrNiv; i++ ) {
        cout << peNivel[i].size() << " ";
        w = 0;
        for ( j = 0; j < peNivel[i].size() - 1; j++ ) {
            cout << peNivel[i][j] << " " << max( nrChildren[peNivel[i][j]], nrParents[peNivel[i][j]] ) << " ";
            w += max( nrChildren[peNivel[i][j]], nrParents[peNivel[i][j]] );
        }
        cout << peNivel[i][j] << " " << wMax - w << "\n";
    }

    return 0;
}
