﻿#include <iostream>
#include <vector>
#include <unordered_map>

using namespace std;
vector<int> ord, used;
int ans = 0;

void gen(int pos, int n) {
    if (pos == n) {
        bool ch = false;
        for (int i = 0; i + 1 < n; ++i) {
            if (ord[i] + 1 == ord[i + 1]) {
                ch = true;
            }
        }
        if (ch) {
            ans++;
        }
        return;
    }
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            used[i] = 1;
            ord.push_back(i);
            gen(pos + 1, n);
            used[i] = 0;
            ord.pop_back();
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
    cin >> n >> m;
    if (n <= 5) {
        used.assign(n, 0);
        gen(0, n);
        cout << ans % m;
        return 0;
    }
    long long vl = 67, d = 2;
    vector<int> ans(m * 2);
    for (int i = 6; i <= min(n, m * 4); ++i) {
        if (i % 2 == 0) {
            d = d * (i - 2) + 1;
        } else {
            d = d * (i - 2) - 1;
        }
        d %= m;
        if (d < 0) {
            d += m;
        }
        vl = vl * i + d;
        vl %= m;
        ans[i % (m * 2)] = vl;
    }
    cout << ans[n % (m * 2)];
    return 0;
}
