#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <iomanip>
#include <cstdio>
#include <stdio.h>
#include <cstdlib>
#include <stdlib.h>
#include <array>
#include <string>
#include <cstring>
#include <algorithm>
#include <cmath>
#include <math.h>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <vector>
#include <stack>
#include <queue>
#include <deque>
#include <tuple>
#include <ctime>
#include <time.h>
#include <climits>
#include <limits.h>
#include <cassert>
#include <assert.h>
#include <random>
#include <utility>
#include <chrono>
#include <fstream>
using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef double db;
typedef long double ld;

#define pr pair
#define mpr make_pair
#define ff first
#define ss second

#define mset multiset
#define mmap multimap
#define uset unordered_set
#define umap unordered_map
#define umset unordered_multiset
#define ummap unordered_multimap
#define pqueue priority_queue

#define sz(x) (x).size()
#define len(x) (x).length()
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define clr(x) (x).clear()

#define lb lower_bound
#define ub upper_bound
#define bs binary_search

void fastio()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	return;
}

void precision(int x)
{
	cout.setf(ios::fixed | ios::showpoint);
	cout.precision(x);
	return;
}

ll binpow(ll a, int b)
{
	ll ans = 1;
	while (b) {
		if ((b & 1) == 1) {
			ans *= a;
		}
		b >>= 1;
		a *= a;
	}
	return ans;
}

ll binpow_by_mod(ll a, ll b, ll mod)
{
	ll ans = 1;
	while (b) {
		if ((b & 1) == 1) {
			ans *= a;
			ans %= mod;
		}
		b >>= 1;
		a *= a;
		a %= mod;
	}
	return ans;
}

ll factorial(int a)
{
	int i;
	ll ans = 1;
	for (i = 1; i <= a; i++) {
		ans *= ll(i);
	}
	return ans;
}

ll factorial_by_mod(int a, ll mod)
{
	int i;
	ll ans = 1;
	for (i = 1; i <= a; i++) {
		ans *= ll(i);
		ans %= mod;
	}
	return ans;
}

// ------------------- SOLUTION ------------------------------ //

/*const int N = 200005;
int a[N];
int n;*/

ll mod0;

ll dp[2005][2005];

void solve()
{
	int i, j;
	int n;
	cin >> n >> mod0;
	dp[1][0] = 1;
	dp[1][1] = 0;
	for (i = 2; i <= n; i++) {
		for (j = 0; j <= i; j++) {
			dp[i][j] = (dp[i - 1][j] * ll(ll(i) - j - 1LL)) + (dp[i - 1][j + 1] * ll(ll(j) + 1LL)) + dp[i - 1][j - 1];
			dp[i][j] %= mod0;
		}
	}
	/*for (i = 1; i <= n; i++) {
		for (j = 0; j < i; j++) {
			cout << dp[i][j] << ' ';
		}
		cout << endl;
	}*/
	cout << (factorial_by_mod(n, mod0) - dp[n][0] + mod0) % mod0 << endl;
	return;
}

void precalc()
{
	int i, j;
	return;
}

int main()
{
	fastio();

	precalc();

	int tests = 1, tc;
	//cin >> tests;
	for (tc = 1; tc <= tests; tc++) {
		solve();
	}
	return 0;
}