#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;
using ll = long long;

ll ans_dumb(ll n) {
    vector<int> v(n);
    for (int i = 0; i < n; ++i)
        v[i] = i;
    vector<int> cv = v;
    ll ans = 0;
    do {
        bool ok = false;
        for (int i = 0; i + 1 < n; ++i) {
            if (v[i + 1] == v[i] + 1)
                ok = true;
        }
        if (ok)
            ++ans;
        next_permutation(v.begin(), v.end());
    } while (cv != v);
    return ans;
}

signed main() {
    ll n, mod;
    cin >> n >> mod;
    if (n == 1) {
        cout << 0 << endl;
        return 0;
    }
    ll add = 0;
    ll x = 1;
    for (int n0 = 2; n0 < n; ++n0) {
        //cout << x << endl;
        x = (x * (n0 + 1) + add) % mod;
        add *= n0;
        if (n0 % 2 == 0)
            ++add;
        else
            --add;
        add = ((add % mod) + mod) % mod;
    }
    cout << x << endl;
}
