#include <iostream>
#include <map>
#include <vector>
using namespace std;
using ll = long long;

//map<pair<pair<ll, ll>, pair<ll, ll>>, ll> mp;

ll mod(ll a, ll m) {
    return (m + (a % m)) % m;
}

ll brute_force(ll freecnt, ll mxvl, ll sm, ll prod) {
    if (prod > freecnt + sm)
        return 0;
    if (prod == freecnt + sm)
        return 1;
    if (freecnt == 0)
        return 0;

    ll p = mod(-(sm + freecnt), prod);
    if (prod * p >= sm + freecnt + 10)
        return 0;

    ll ans = 0;
    for (ll k = 2; k <= mxvl; ++k) {
        if (prod * k > freecnt + sm + k)
            break;
        ans += brute_force(freecnt - 1, k, sm + k, prod * k);
    }
    //if (ans > 0 && freecnt == 99999)
        //cout << ans << "(" << freecnt << ' ' << mxvl << ' ' << sm << ' ' << prod << ")" << endl;
    return ans;
}

ll get_ans(ll n) {
    return brute_force(n, n + 10, 0, 1);
}

signed main() {
    ll n;
    cin >> n;
    cout << get_ans(n) << endl;
    return 0;
    for (int n0 = 2; n0 <= n; ++n0) {
        cout << get_ans(n0) << ' ';
    }
    cout << endl;
}
