#include <iostream>

using namespace std;
using ll = long long;

const int MAX = 1005;

ll f[MAX];
ll dp[MAX][MAX];//[MAX];

int main() {
  ll n, m;

  cin >> n >> m;

  f[0] = 1;
  for ( int i = 1; i <= n; ++i ) {
    f[i] = (f[i-1] * i) % m;
  }
  dp[1][0] = 1;
  for ( int i = 2; i <= n; ++i ) {
    for ( int j = 0; j <= i; ++j ) {
      if ( j == 0 ) {
        dp[i][j] = (dp[i-1][j] * (i - j - 1) + dp[i-1][j+1]) % m;
        continue;
      }
      dp[i][j] = (dp[i-1][j] * (i - j - 1) + dp[i-1][j+1] + dp[i-1][j-1] * j) % m;
    }
  }
  ll res = dp[n][0];
  //cout << res << "\n";
  cout << (f[n] - res + m) % m;
  return 0;
}

