#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>

using namespace std;

typedef long long ll;

ll result = 0;
ll n, m;
vector<bool> used;
vector<ll> fact;

void recur(ll ost, ll pred)
{
    if (ost == 0)
    {
        return;
    }
    for (ll i = 0; i < n; ++i)
    {
        if (!used[i])
        {
            if (i == pred + 1)
            {
                result += fact[ost - 1];
                if (result > m)
                    result %= m;
            }
            else
            {
                used[i] = true;
                recur(ost - 1, i);
                used[i] = false;
            }
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n >> m;
    used.resize(n);
    fact.resize(21);
    fact[0] = 1;
    for (ll i = 1; i <= 20; ++i)
    {
        fact[i] = fact[i - 1] * i;
    }
    recur(n, -2);
    cout << result << '\n';
    return 0;
}