#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>

using namespace std;

typedef long long ll;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    ll n, m;
    cin >> n >> m;
    vector<ll> pretty(n + 1);
    vector<ll> not_pretty(n + 1);
    vector<ll> dob(n + 1);
    vector<ll> summ(n + 1);
    pretty[0] = 0;
    not_pretty[0] = 1;
    dob[0] = 0;
    summ[0] = 0;
    if (n >= 3)
        dob[3] = 1;
    pretty[1] = 0;
    not_pretty[1] = 1;
    dob[1] = 0;
    summ[1] = 0;
    ll x = 1;
    for (ll i = 2; i <= n; ++i)
    {
        x *= i;
        x %= m;
        pretty[i] = (not_pretty[i - 1] + (pretty[i - 1] * (i - 1)) % m + dob[i - 1]) % m;
        not_pretty[i] = (x + m - pretty[i]) % m;
        if (i > 3)
        {
            dob[i] = summ[i - 1];
        }
        summ[i] = summ[i - 1] + pretty[i] + 1;
    }
    cout << pretty[n] << '\n';
    return 0;
}