#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>

using namespace std;

typedef long long ll;

ll result = 0;
ll n = 0;
ll twopow = 1;

void recur(ll proizv, ll summ, ll minimum, ll used)
{
    if (summ + (n - used) == proizv)
    {
        ++result;
        return;
    }
    if (used >= n)
        return;
    ll i = minimum;
    while (proizv * i <= summ + i + (n - used - 1) && i <= 100000000)
    {
        recur(proizv * i, summ + i, i, used + 1);
        ++i;
    }
    return;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n;
    if (n == 2)
        cout << 1 << '\n';
    else
    {
        ll num = 2;
        while (num <= n)
        {
            num *= 2;
            ++twopow;
        }
        num /= 2;
        recur(1, 0, 2, 0);
        cout << result << '\n';
    }
    return 0;
}