#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const ll MOD = 1e9+7;

ll n;

ll func(ll p, ll s, ll l, vector<int> v) {
    ll x = n - v.size();
    if (x == 0 && p == s) {
//        for (int i : v) {
//            cout << i << ' ';
//        }
//        cout << endl;
        return 1;
    }
    else if (x == 0) {
        return 0;
    }
    ll ans = 0;
    for (int i = 1; i <= l; i++) {
        if (p * i <= s + i + (x - 1)) {
            v.push_back(i);
            ans += func(p * i, s + i, i, v);
            v.pop_back();
        }
    }
    return ans;
}

ll pow(ll a, ll b) {
    if (b == 0) {
        return 1;
    }
    if (b % 2 == 1) {
        return (pow(a, b - 1) * a) % MOD;
    }
    else {
        ll x = pow(a, b / 2);
        return (x * x) % MOD;
    }
}

map<ll, ll> factor(ll x) {
    map<ll, ll> ans;
    for (int i = 2; i <= sqrt(x); i++) {
        while (x % i == 0) {
            ans[i]++;
            x /= i;
        }
    }
    if (x != 1) {
        ans[x]++;
    }
    return ans;
}

ll phi(ll x) {
    map<ll, ll> mp = factor(x);
    ll ans = 1;
    for (auto i : mp) {
        ans *= pow(i.first, i.second) - i.second;
    }
    return ans;
}

ll num_div(ll x) {
    map<ll, ll> mp = factor(x);
    ll ans = 1;
    for (auto i : mp) {
        ans *= (i.second + 1);
    }
    return ans;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    cout << func(1, 0, n, vector<int>(0)) << '\n';
}
