#include<bits/stdc++.h>
typedef long long ll;

using namespace std;

ll sum(ll a, ll b, ll m) {
	if (a + b >= m) {
		return a + b - m;
	}
	return a + b;
}

ll sub(ll a, ll b, ll m) {
	if (a - b < 0) {
		return a - b + m;
	}
	return a - b;
}

ll mul(ll a, ll b, ll m) {
	return a * b % m;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	ll n, m;
	cin >> n >> m;
	if (n == 1) {
		cout << 0;
		return 0;
	}
	ll ans = n;
	vector<ll> dp(n + 1, 0);
	dp[0] = 1;
	dp[1] = 1;
	for (ll i = 2; i < n; i++) {
		vector<ll> ndp(n + 1, 0);
		ans = mul(ans, i, m);
		for (ll j = 0; j < i; j++) {
			ndp[j] = sum(ndp[j], mul(dp[j], i - j, m), m);
			ndp[j + 1] = sum(ndp[j + 1], dp[j], m);
			if (j > 0) {
				ndp[j - 1] = sum(ndp[j - 1], mul(dp[j], j, m), m);
			}
		}
		dp = ndp;
	}
	cout << sub(ans, dp[0], m);
}
