#include<bits/stdc++.h>
typedef long long ll;

using namespace std;

ll sum(ll a, ll b, ll m) {
	if (a + b >= m) {
		return a + b - m;
	}
	return a + b;
}

ll sub(ll a, ll b, ll m) {
	if (a - b < 0) {
		return a - b + m;
	}
	return a - b;
}

ll mul(ll a, ll b, ll m) {
	return a * b % m;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	ll n, m;
	cin >> n >> m;
	vector<vector<ll>> sons(n), parents(n);
	for (ll i = 0; i < m; i++) {
		ll a, b;
		cin >> a >> b;
		a--;
		b--;
		sons[a].push_back(b);
		parents[b].push_back(a);
	}
	vector<ll> dist(n, -1);
	queue<ll> q;
	for (ll i = 0; i < n; i++) {
		if (parents[i].size() == 0) {
			q.push(i);
			dist[i] = 0;
		}
	}
	vector<vector<ll>> arr;
	while (!q.empty()) {
		ll now = q.front();
		if (arr.size() <= dist[now]) {
			arr.push_back(vector<ll>(0, 0));
		}
		arr.back().push_back(now);
		q.pop();
		for (auto i : sons[now]) {
			if (dist[i] == -1) {
				dist[i] = dist[now] + 1;
				q.push(i);
			}
		}
	}
	for (auto& i : arr) {
		sort(i.begin(), i.end());
	}
	for (auto& i : sons) {
		sort(i.begin(), i.end());
	}
	for (auto& i : parents) {
		sort(i.begin(), i.end());
	}
	vector<ll> dp(n, 1);
	bool b = true;
	while (b) {
		b = false;
		for (ll i = 0; i < arr.size() - 1; i++) {
			ll u = 0, colv = 0, coln = 0;
			for (auto j : arr[i]) {
				while (u < arr[i + 1].size() && parents[arr[i + 1][u]].back() == j) {
					u++;
					coln += dp[u - 1];
				}
				if (j == arr[i].back()) {
					if (dp[j] < coln - colv) {
						dp[j] = coln - colv;
						b = true;
					}
				} else {
					if (dp[j] < coln - colv + 1) {
						dp[j] = coln - colv + 1;
						b = true;
					}
				}
				colv += dp[j];
				if (u < arr[i + 1].size()) {
					if (dp[arr[i + 1][u]] < colv - coln + 1) {
						dp[arr[i + 1][u]] = colv - coln + 1;
						b = true;
					}
				}
			}
		}
		reverse(arr.begin(), arr.end());
		swap(sons, parents);
		for (ll i = 0; i < arr.size() - 1; i++) {
			ll u = 0, colv = 0, coln = 0;
			for (auto j : arr[i]) {
				while (u < arr[i + 1].size() && parents[arr[i + 1][u]].back() == j) {
					u++;
					coln += dp[u - 1];
				}
				if (j == arr[i].back()) {
					if (dp[j] < coln - colv) {
						dp[j] = coln - colv;
						b = true;
					}
				} else {
					if (dp[j] < coln - colv + 1) {
						dp[j] = coln - colv + 1;
						b = true;
					}
				}
				colv += dp[j];
				if (u < arr[i + 1].size()) {
					if (dp[arr[i + 1][u]] < colv - coln + 1) {
						dp[arr[i + 1][u]] = colv - coln + 1;
						b = true;
					}
				}
			}
		}
		reverse(arr.begin(), arr.end());
		swap(sons, parents);
	}
	ll ah = 0;
	for (auto j : arr[0]) {
		ah += dp[j];
	}
	cout << arr.size() << ' ' << ah << '\n';
	for (auto& i : arr) {
		cout << i.size() << ' ';
		for (auto j : i) {
			cout << j + 1 << ' ' << dp[j] << ' ';
		}
		cout << '\n';
	}
}
