#include <iostream>
#include <list>
#include <string>
#include <vector>

long long factorial(long long n)
{
	long long product = 1;
	for (long long i = 2; i <= n; i++)
		product *= i;
	return product;
}

long long permutate(long long N, long long M, std::vector<long long> current = {}, std::list<long long> whitelist = {})
{
	if (N == 0) return 0;

	long long count = 0;

	if (!whitelist.size())
		for (long long i = 1; i <= N; i++)
			whitelist.push_back(i);
	
	for (auto i : whitelist) {
		auto copy = whitelist;
		copy.remove(i);
		current.push_back(i);
		if (current.size() > 1 && current[current.size() - 1] == current[current.size() - 2] + 1)
			count += factorial(N - 1);
		else
			count += permutate(N - 1, M, current, copy);
		count %= M;
		current.pop_back();
	}
	return count;
}


int main()
{
	std::cin.tie(0); std::cout.tie(0);
	long long N, M;
	std::cin >> N >> M;
	std::cout << permutate(N, M);

	return 0;
}

//factorial(N - 1) * (N - 1); // Amount of [x, x+1]. But there are intersections.