#define _CRT_SECURE_NO_WARNINGS

#define MOD 1000000000
#define INF 1000000007
#define cn const
#define push_back pb
#define ff first
#define ss second
#define sz size()
#define all(x) x.begin(), x.end()
#define sortall(x) sort(all(x))

#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <queue>
#include <string>
#include <deque>
#include <iomanip>
#include <map>
#include <set>
#include <cstdlib>

#define endl '\n'


using namespace std;


using ll = long long;
using ull = unsigned long long;
using pll = pair<ll, ll>;
using pii = pair<int, int>;
using vi = vector<int>;
using vl = vector<ll>;
using ld = long double;
using vs = vector<string>;
using vpii = vector<pii>;


template<typename T>
constexpr T sqr(const T& x)
{
	return x * x;
}

template<typename T>
bool rMin(T& v, const T& rval)
{
	if (rval < v)
	{
		v = rval;
		return true;
	}
	return false;
}

template<typename T>
bool rMax(T& v, const T& rval)
{
	if (v < rval)
	{
		v = rval;
		return true;
	}
	return false;
}


ll n, m;

ll FactMod(ll x)
{
	if (m <= x)
	{
		return 0;
	}

	ll res = 1;
	for (int i = 2; i <= x; i++)
	{
		res = (res * i) % m;
	}

	return res;
}


ll Fact(ll x)
{
	ll res = 1;
	for (int i = 2; i <= x; i++)
	{
		res = (res * i);
	}

	return res;
}


void solve()
{
	cin >> n >> m;

	ll fixed = Fact(n - 1);

	ll Plus = Fact(n - 2);
	ll res = fixed * 2 - Plus;
	ll last = fixed - Plus;
	ll lastFact = Fact(n - 2);

	ll curr;
	for (int i = 3; i < n; i++)
	{
		ll currFact = lastFact / (n - i + 1);

		if (i == 3)
		{
			curr = last - Plus + currFact;
		}
		else
		{
			curr = last - Plus + lastFact + currFact;
		}

		lastFact = currFact;
		res += curr;
		last = curr;
	}

	cout << res % m << endl;
}



int main()
{
#ifdef _DEBUG
	freopen("Input.txt", "r", stdin);
#endif // _DEBUG
	
	ios::sync_with_stdio(false);
	cin.tie(0);



	int t = 1;
	//cin >> t;

	while (t--)
	{
		solve();
	}



#ifdef _DEBUG
	cin.get();
#endif // _DEBUG

	return 0;
}