#include <bits/stdc++.h>

#define pb push_back

using namespace std;

using ll = long long;

vector<int> g[200200];
vector<int> topologic_sort;
bool used[200200];
int depth[200200];
int maxdepth;
int n, m;
map<pair<int, int>, bool> ye;
int children[200200];
int pars[200200] = {};
int childs[200200] = {};
int sh[200200];

void dfs(int v)
{
    used[v] = 1;
    for (auto u : g[v])
        if (!used[u])
            dfs(u);
    topologic_sort.pb(v);
}

void sort_graph()
{
    for (int i = 1; i <= n; i++)
        if (!used[i])
            dfs(i);
    reverse(topologic_sort.begin(), topologic_sort.end());
}

void ddffss(int v, int p = -1)
{
    used[v] = 1;
    if (p != -1) depth[v] = depth[p] + 1;
    for (auto u : g[v])
    {
        if (!used[u])
            ddffss(u, v);
    }
}

void find_depth()
{
    fill(used + 1, used + n + 1, false);
    for (auto u : topologic_sort)
    {
        if (!used[u]) ddffss(u);
    }
    maxdepth = *max_element(depth + 1, depth + n + 1) + 1;
}

void DFS(int v, int p = -1)
{
    used[v] = 1;
    if (g[v].empty())
    {
        sh[v] = pars[v];
        return;
    }
    for (auto u : g[v])
    {
        if (!used[u]) DFS(u);
    }
    for (auto u : g[v])
    {
        sh[v]++;
    }
}

void find_shirs()
{
    fill(used + 1, used + n + 1, false);
    for (auto u : topologic_sort)
    {
        if (!used[u]) DFS(u);
    }
}

int main()
{
    ios::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    cin >> n >> m;
    int u[m + 1], d[m + 1];
    for (int i = 1; i <= m; i++)
    {
        cin >> u[i] >> d[i];
        ye[{u[i], d[i]}] = 1;
    }
    int vozr;
    cin >> vozr;
    if (vozr == 0)
    {
        int par[n + 1] = {};
        for (int i = 1; i <= n; i++)
            par[i] = -1;
        for (int i = 1; i <= m; i++)
        {
            par[d[i]] = u[i];
            g[u[i]].push_back(d[i]);
        }
        sort_graph();
        for (auto u : topologic_sort)
            cout << u << ' ';
        cout << '\n';
        find_depth();
        for (int i = 1; i <= n; i++)
            cout << depth[i] << ' ';
        cout << '\n' << '\n';
        vector<int> ans[maxdepth + 1];
        for (int i = 1; i <= n; i++)
            ans[depth[i] + 1].push_back(i);
        for (int i = 1; i <= maxdepth; i++)
        {
            for (auto u : ans[i]) cout << u << ' ';
            cout << '\n';
        }
    }
    else
    {
        int par[n + 1] = {};
        for (int i = 1; i <= n; i++)
            par[i] = -1;
        for (int i = 1; i <= m; i++)
        {
            par[d[i]] = u[i];
            g[u[i]].push_back(d[i]);
        }
        sort_graph();
//        for (auto u : topologic_sort)
//            cout << u << ' ';
//        cout << '\n';
        find_depth();
//        for (int i = 1; i <= n; i++)
//            cout << depth[i] << ' ';
//        cout << '\n' << '\n';
        vector<int> ans[maxdepth + 1];
        for (int i = 1; i <= n; i++)
            ans[depth[i] + 1].push_back(i);
//        for (int i = 1; i <= maxdepth; i++)
//        {
//            for (auto u : ans[i]) cout << u << ' ';
//            cout << '\n';
//        }
        for (int i = 1; i <= m; i++)
        {
            pars[d[i]]++;
            childs[u[i]]++;
        }
        find_shirs();
        int kkk = 0;
        for (auto u : ans[maxdepth]) kkk += sh[u];
        cout << maxdepth << ' ' << kkk << '\n';
        for (int i = 1; i <= maxdepth; i++)
        {
            cout << ans[i].size() << ' ';
            for (auto u : ans[i]) cout << u << ' ' << sh[u] << ' ';
            cout << '\n';
        }
    }
}
