/*
Hai mișcă-te tare, tare,
Dă-i motoare cu valoare!
 
Паля 200 цигари, газя като Ферари,
но пак не ще да ми мине,
цяла нощ не спирам да те мисля и боли ме
*/

#include <iostream>
#include <map>
#include <cstring>
#define int long long
using namespace std;
const int maxn = 20, maxb = (1 << 20);

int dp[maxn][maxb];
int n, m;

int f(int ix, int last, int mask) {

    if (ix == n) return 1;
    if (dp[last][mask] != -1) return dp[last][mask];
    dp[last][mask] = 0;

    for (int i = 0 ; i < n ; ++i) {

        if (mask & (1 << i) || i == last+1) continue;
        dp[last][mask] += f(ix+1, i, mask | (1 << i));
        if (dp[last][mask] >= m) dp[last][mask] -= m;

    } 

    return dp[last][mask];

}

void solve() {

    cin >> n >> m;
    for (int i = 0 ; i < n ; ++i)
        fill(dp[i], dp[i]+maxb, -1);

    int fact = 1;
    for (int i = 2 ; i <= n ; ++i)
        fact = (i * fact) % m;
        
    fact -= f(0, n-1, 0);
    if (fact < 0) fact += m;

    cout << fact << '\n';

}


signed main () {

    solve();
    return 0;

}