/*
Hai mișcă-te tare, tare,
Dă-i motoare cu valoare!
 
Паля 200 цигари, газя като Ферари,
но пак не ще да ми мине,
цяла нощ не спирам да те мисля и боли ме
*/

#include <iostream>
#include <map>
#define int long long
using namespace std;

struct key {

    int pos;
    long long prod, sum;

    key() {

        pos = prod = sum = 0;

    }

    key(int _pos, long long _prod, long long _sum) {

        pos = _pos;
        prod = _prod;
        sum = _sum;

    }

    inline friend bool operator < (key a, key b) {

        return a.prod < b.prod;

    }

};

map < key, long long > dp;
long long n, curr;

long long f(int pos, long long prod, long long sum, long long last, int maxvalue) {

    // cout << "call: " << pos << ' ' << prod << ' ' << sum << ' ' << maxvalue << '\n';
    if (prod - sum == n - curr && pos == curr) return 1;
    if (pos == curr || prod - sum > n - pos) return 0;
    // if (dp.count({pos, prod, sum})) return dp[{pos, prod, sum}];

    long long ans = 0;
    for (int i = 2 ; i <= last ; ++i)
        ans += f(pos+1, prod * i, sum + i, i, maxvalue/i);

    // cout << "f: " << pos << ' ' << prod << ' ' << sum << " = " << ans << '\n';
    return dp[{pos, prod, sum}] = ans;

}

long long power(int x, int base, int num) {

    if (base == 0) return 1;
    if (base & 1) return min(num+1, x * power(x, base-1, num));
    long long res = power(x, base/2, num);
    return min(res*res, num+1);

}

void solve() {

    cin >> n;
    long long ans = 1;
    for (int i = 3 ; (1ll << i) <= 2*n && i <= n ; ++i) {

        dp.clear();
        curr = i;
        ans += f(0, 1, 0, 1000*n, 2*n);

    }

    cout << ans << '\n';

}

signed main () {

    solve();
    return 0;

}