#include <bits/stdc++.h>
using namespace std;

#define int long long
#define mp make_pair
#define pb push_back

const int N = (int)2e5 + 11;

vector<int> g[N],gt[N];
int sz[N];

vector<int> layer[N];
int deep[N];
bool used[N];

vector<int> S;
int mn[N],mx[N];
void dfs(int v){
    if(used[v])
        return;
    used[v] = true;
    S.clear();
    int sum = 0;
//    cerr << v << "\n";
    sort(g[v].begin(),g[v].end());
    for(auto& x : g[v]){
        deep[x] = deep[v] + 1;
        if(!used[x])
            dfs(x);
        S.pb(sz[x]);
    }
    for(int i = 1; i < (int)S.size() - 1; i++){
        sum += S[i];
    }
    if(S.size() > 1)
        sum++;
    if(S.size() > 3)
        sum++;
    sz[v] = max(sz[v],sum);
    return;
}

void solve(){
    int n,m;
    cin >> n >> m;

    for(int i = 0; i < m; i++){
        int a,b;
        cin >> a >> b;
        g[a].pb(b);
        gt[b].pb(a);
        sz[b]++;
    }

    int d;
    cin >> d;

    for(int i = 1; i <= n; i++){
        sz[i] = max(sz[i],1ll);
    }

    for(int i = 1; i <= n; i++){
        if(!used[i]){
            deep[i] = 1;
            dfs(i);
        }
    }

    int mx = 0;

    for(int i = 1; i <= n; i++){
        layer[deep[i]].pb(i);
        mx = max(mx,deep[i]);
    }

    cout << mx << " ";

    vector<int> pos(n+1,0);
    int cur = 0;

    for(auto& x : layer[mx]){
        pos[x] = cur + sz[x];
    }

    int w = 0;

    for(int i = mx - 1; i >= 1; i--){
        cur = 0;
        for(auto& x : layer[i]){
            pos[x] = cur + sz[x];
            cur += sz[x];
        }
        w = max(w,cur);
    }

    for(int i = 1; i <= mx; i++){
        pos[layer[i].back()] = w;
    }

    cout << w << "\n";

    for(int i = 1; i <= mx; i++){
        cout << layer[i].size() << " ";
        int pr = 0;
        for(auto& x : layer[i]){
            cout << x << " " << pos[x] - pr << " ";
            pr = pos[x];
        }
        cout << "\n";
    }

    return;
}
/**

11 8
1 7
1 8
2 9
3 9
4 9
5 10
6 10
6 11

**/
signed main(){
    ios::sync_with_stdio(false);cin.tie(nullptr);cout.tie(nullptr);
    int tests = 1;
    for(int _ = 1; _ <= tests; _++){
        solve();
    }
    return 0;
}
