#include <bits/stdc++.h>
#define ll long long
#define ld long double
#define point pair<ll,ll>
#define ff first
#define ss second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define show(x) cout << (#x) << ' ' << x << '\n'
using namespace std;

const int N = 1e6 + 64;
const int INF = INT_MAX;
const int MOD = 1e9 + 7;
const int LOG = 31;

vector<int> g[N], gr[N], dep(N, -INF), sz(N);
vector<vector<point>> layers;
vector<vector<int>> p;

void dfs (int v) {
    for (auto it : g[v])
        if (dep[it] == -INF)
            dep[it] = dep[v] + 1, dfs(it);
}

signed main() {
    int n, m;
    cin >> n >> m;
    for (int i = 1; i <= m; ++i) {
        int u, v; cin >> u >> v;
        g[u].push_back(v);
        gr[v].push_back(u);
    }

    for (int i = 1; i <= n; ++i) {
        if (gr[i].empty())
            dep[i] = 0, dfs(i);
    }

    int depth = *max_element(all(dep)) + 1;
    layers.resize(depth), p.resize(depth);

    //show("ABOBA"); show(depth);
    for (int i = 1; i <= n; ++i)
        layers[dep[i]].push_back({i, max(g[i].size(), gr[i].size())});

    //show("ABOBA");

    int mx = 0;
    for (int i = 0; i < depth; ++i) {
        int cur = 0;
        for (auto it : layers[i])
            cur += it.ss, sz[it.ff] = it.ss;
        mx = max(mx, cur);
    }

//    for (int step = 0; step < 1; ++step) {
//        for (int i = 1; i <= n; ++i) {
//            int sum1 = 0, sum2 = 0;
//            for (auto it : gr[i])
//                sum2 += it;
//
//            sz[i] = max({sz[i], sum2});
//        }
//
//        for (auto& it : layers)
//            for (auto& it2 : it)
//                it2.ss = max(it2.ss, (ll) sz[it2.ff]);
//    }

    //show("ABOBA");

    cout << depth << ' ' << mx << '\n';
    for (auto it : layers) {
        sort(all(it));
        cout << it.size() << ' ';
        for (auto it2 : it)
            cout << it2.ff << ' ' << it2.ss << ' ';
        cout << '\n';
    }
    int x; cin >> x;
}
