#include <iostream>
#include <fstream>

using namespace std;

#ifdef MY_MAC
ifstream f("input.txt");
#define cin f
#endif

const int mxN = 1e18+5;

int n, MOD;
int a[mxN];

void buildA() {
	a[1] = 1;
	a[2] = 2;
	for (int i = 3; i <= n; i++) {
		a[i] = ((a[i-1] % MOD) * (i + 2)) % MOD;
		a[i] += i % 2 ? -1 : 1;
	}
}

int main() {
	cin >> n >> MOD;
	n++;

	buildA();
	int n1 = 1, n2 = 0;
	int64_t ans = 1;
	for (int i = 3; i < n; i++) {
		n2 = ans % MOD;
		n1 = (n2 + (a[i-3] % MOD)) % MOD;
		ans = (n1 + (n2 * (i - 1))) % MOD;
	}

	cout << ans;

	return 0;
}