#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <queue>
#include <stack>
#include <bitset>
#include <math.h>
#include <fstream>
#include <iomanip>
#include <functional>


using namespace std;

using ll = long long;
using ld = long double;
using vll = vector<ll>;
using vld = vector<ld>;
using vvld = vector<vld>;
using vstr = vector<string>;
using pll = pair<ll, ll>;
using vpll = vector<pll>;
using vvpll = vector<vpll>;


int main()
{
	ll n;
	cin >> n;
	ll m;
	cin >> m;
	vll arr1(n);
	vll arr2(n);
	for (ll i = 0; i < n; i++)
	{
		arr1[i] = 0;
	}
	arr1[0] = 1;
	for (ll col = 2; col <= n; col++)
	{
		for (ll row = 0; row < n; row++)
		{
			arr2[row] = 0;
			if (row - 1 >= 0)
			{
				arr2[row] += arr1[row - 1];
			}
			arr2[row] += (col - (row + 1)) * arr1[row];
			if (row + 1 < n)
			{
				arr2[row] += (row + 1) * arr1[row + 1];
			}
			arr2[row] = arr2[row] % m;
		}
		for (ll i = 0; i < n; i++)
		{
			arr1[i] = arr2[i];
		}
	}
	ll ans = 0;
	for (ll i = 1; i < n; i++)
	{
		ans += arr1[i];
		ans = ans % m;
	}
	cout << ans << endl;
}

//C:\Users\user\source\repos