#include <iostream>
#include <vector>
#include <algorithm>
#define x first
#define y second
#define all(v) v.begin(), v.end()
#define chkmin(a, b) a = min(a, b)
#define chkmax(a, b) a = max(a, b)
using namespace std;
typedef long long ll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<bool> vb;

int ans = 0;

void Solve(int n, int last, ll l, ll r) {
    if (!n) {
//        if (l == r) {
            ans += l == r;
//        }
        return;
    }
    if (n == 1) {
        if (!(r % (l - 1))) {
            ans += (r / (l - 1)) >= last;
        }
        return;
    }
    for (ll x = last; x * l <= x + r; x++) {
        Solve(n - 1, x, l * x, r + x);
    }
}

int Log(int j) {
    if (j == 1) return 0;
    return Log(j / 2) + 1;
}

int main() {
    int n;
    cin >> n;
    for (int j = n; j <= n; j++) {
        ans = 0;
        int cnt = 0;
        int loga = Log(j);
        for (int i = j - 2; i >= 0 && cnt < loga; i--, cnt++) {
            for (int k = 0; k < n - i - 1; k++) {
                for (ll x = 3; x * x * (1ll << k) < i + 2 * x + 2 * k; x++) {
                    Solve(n - i - k - 1, x, x * (1ll << k), i + x + 2 * k);
                }
            }
            ll pow = 1ll << (n - i - 1);
            if (pow && !((i + 2 * (n - i - 1)) % (pow - 1))) {
                ll x = (i + 2 * (n - i - 1)) / (pow - 1);
                if (x != 2) ans++;
            }
            pow <<= 1;
            if (pow == 2 * n - i) ans++;
//            for (ll x = 2; x * x <= i + 2 * x; x++) {
//                Solve(j - i - 1, x, x, i + x);
//            }
        }
    }
    cout << ans;
}
