#include <iostream>
#include <vector>
#include <algorithm>
#define x first
#define y second
#define all(v) v.begin(), v.end()
#define chkmin(a, b) a = min(a, b)
#define chkmax(a, b) a = max(a, b)
using namespace std;
typedef long long ll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<bool> vb;

int ans = 0;

int Log(int j) {
    if (j == 1) return 0;
    return Log(j / 2) + 1;
}

ll Power(ll a, int b) {
    if (!b) return 1;
    return Power(a * a, b / 2) * (b & 1 ? a : 1);
}

void Solve(int n, int last, ll l, ll r) {
    if (!n) {
//        if (l == r) {
        ans += l == r;
//        }
        return;
    }
    if (n == 1) {
        if (!(r % (l - 1))) {
//            if ((r / (l - 1)) >= last) {
            ans += (r / (l - 1)) >= last;
//            }
        }
        return;
    }
    for (ll x = last; x * l <= x + r; x++) {
        ll pow = 1;
        for (int j = 0; j < n; j++) {
            pow *= x;
            if (l + pow > r + x * (n)) break;
        }
        if (l + pow > r + x * (n)) break;
        Solve(n - 1, x, l * x, r + x);
    }
}

int main() {
    int n;
    cin >> n;
    ans = 0;
    int cnt = 0;
    for (int i = n - 2; i >= 0; i--, cnt++) {
        if (Power(2, n - i) > i + 2 * (n - i)) break;
        for (ll x = 2; true; x++) {
            ll pow = 1;
            for (int j = 0; j < n - i; j++) {
                pow *= x;
                if (pow > i + x * (n - i)) break;
            }
            if (pow > i + x * (n - i)) break;
            Solve(n - i - 1, x, x, i + x);
        }
    }
    cout << ans;
}