#include <bits/stdc++.h>

using namespace std;

int n, m;
vector<vector< int >> grp;
vector<vector< int >> grp1;
map< pair<int,int>, int > len;

vector<int> h;

void dfs ( int v, int d )
{
    if ( h[v] != 0 )
        return;

    h[v] = d;

    for ( auto& to : grp[v] )
        dfs( to, d+1 );
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    cin >> n >> m;

    grp.assign( n+1, vector<int>() );
    grp1.assign( n+1, vector<int>() );
    h.assign( n+1, 0 );

    for ( int i=0; i<m; i++ )
    {
        int u, v;
        cin >> u >> v;
        grp[v].push_back( u );
        grp1[u].push_back( v );
        len[pair<int,int>(u,v)] = 1;
        len[pair<int,int>(v,u)] = 1;
    }

    int t;
    cin >> t;

    vector<bool> used(n+1, false);
    queue<int> q;

    for ( int i=1; i<=n; i++ )
        q.push( i );

    vector<int> del( n+1, 0 );
    for ( int i=1; i<=n; i++ )
    for ( auto& to : grp[i] )
    {
        del[to] -= len[pair<int,int>(to, i)];
        del[i]  += len[pair<int,int>(i, to)];
    }

    while ( q.size() )
    {
        int v = q.front();
        q.pop();

        //cout << "Q: " << v << '\n';

        int sum1 = 0;
        int sum2 = 0;

        for ( auto& to : grp[v] )
            sum1 += len[pair<int,int>( to, v )];

        for ( auto& to : grp1[v] )
            sum2 += len[pair<int,int>( v, to )];

        int sum = max( sum1, sum2 );

        if ( sum1 < sum && grp[v].size() )
        {
            int add = sum-sum1;

            for ( auto& to : grp[v] )
            if ( add && del[to] > 0 )
            {
                int mini = min( del[to], add );
                add -= mini;
                del[to] -= mini;
                len[pair<int,int>( to, v )] += mini;
                len[pair<int,int>( v, to )] += mini;
                if ( used[to] )
                {
                    used[to] = false;
                    q.push( to );
                }
            }

            int to = grp[v][0];
            len[pair<int,int>( to, v )] += add;
            len[pair<int,int>( v, to )] += add;

            if ( add && used[to] )
            {
                used[to] = false;
                q.push( to );
            }
        }

        if ( sum2 < sum && grp1[v].size() )
        {
            int add = sum-sum2;

            for ( auto& to : grp1[v] )
            if ( add && del[to] < 0 )
            {
                int mini = min( -del[to], add );
                add -= mini;
                del[to] += mini;
                len[pair<int,int>( to, v )] += mini;
                len[pair<int,int>( v, to )] += mini;
                if ( used[to] )
                {
                    used[to] = false;
                    q.push( to );
                }
            }

            int to = grp1[v][0];
            len[pair<int,int>( to, v )] += add;
            len[pair<int,int>( v, to )] += add;

            if ( add && used[to] )
            {
                used[to] = false;
                q.push( to );
            }
        }

        used[v] = true;
    }

    //cout << "HERE\n";

    vector<int> w(n+1, 0);

    for ( int i=1; i<=n; i++ )
    for ( auto& to : grp[i] )
    {
        w[to] += len[pair<int,int>( to, i )];
        //w[i]  += len[pair<int,int>( to, i )];
        if ( grp1[i].size() == 0 )
            w[i]  += len[pair<int,int>( to, i )];
    }

    /*for ( int i=1; i<=n; i++ )
        w[i] /= 2;*/

    for ( int i=1; i<=n; i++ )
    if ( grp1[i].size() == 0 )
        dfs( i, 1 );

    int hgt = 0;
    for ( int i=1; i<=n; i++ )
        hgt = max( hgt, h[i] );

    vector< vector< pair<int,int> > > ans( hgt );

    for ( int i=1; i<=n; i++ )
        ans[hgt-h[i] ].push_back({ i, w[i] });

    int wgh = 0;
    for ( auto& [x,y] : ans[0] )
        wgh += y;

    cout << hgt << ' ' << wgh << '\n';

    for ( int i=0; i<hgt; i++ )
    {
        cout << ans[i].size() << ' ';
        for ( auto& [x,y] : ans[i] )
            cout << x << ' ' << y << ' ';
        cout << '\n';
    }

    return 0;
}
