#include<bits/stdc++.h>

using namespace std;

#define int long long
#define ld long double
#define pb push_back

mt19937 rnd(51);

const int N = 1e5 + 10;
vector<int> g[N], gr[N];

int merge(int l, int r, int ll, int rr){
    return max(l, ll) <= min(r, rr);
}

signed main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL
    ios::sync_with_stdio(0);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; i++){
        int a, b;
        cin >> a >> b;
        a--, b--;
        g[a].pb(b);
        gr[b].pb(a);
    }
    vector<int> val(n), good(n);
    vector<pair<int,int>> seg(n);
    vector<vector<int>> sz;
    for (int i = 0; i < n; i++){
        val[i] = max((int)g[i].size(), (int)gr[i].size());
    }
    vector<int> qq;
    for (int i = 0; i < n; i++){
        if (gr[i].size() == 0){
            qq.pb(i);
        }
    }
    while(qq.size() > 0){
        sz.pb(qq);
        vector<int> u;
        for (auto to : qq){
            for (auto t : g[to]){
                u.pb(t);
            }
        }
        sort(u.begin(), u.end());
        u.erase(unique(u.begin(), u.end()), u.end());
        qq = u;
    }
    set<int> st;
    for (int i = 0; i < sz.size(); i++){
        int sum = 0;
        for (auto to : sz[i]){
            sum += val[to];
        }
        st.insert(sum);
    }
    deque<int> q;
    int mx = *st.rbegin(), w = sz.size();
    for (int i = 0; i < w; i++){
        sort(sz[i].begin(), sz[i].end());
        int sum = 0;
        for (auto to : sz[i]){
            sum += val[to];
        }
        if (sum == mx){
            int now = 1;
            for (auto to : sz[i]){
                seg[to] = {now, now + val[to] - 1};
                now += val[to];
            }
            good[i] = 1;
            q.pb(i - 1), q.pb(i + 1);
        }
    }
    while(q.size() > 0){
        int i = q.front();
        q.pop_front();
        if (i < 0 || i >= w){
            continue;
        }
        if (good[i]) continue;
        good[i] = 1;
        if (i + 1 < w && good[i + 1]){
            int now = 1;
            for (auto v : sz[i]){
                int l = -1, r = n + 1;
                while(r - l > 1){
                    int mid = (r + l) / 2;
                    bool x = 0;
                    for (auto to : g[v]){
                        if (!merge(now, now + val[v] + mid - 1, seg[to].first, seg[to].second)){
                            x = 1;
                        }
                    }
                    if (!x){
                        r = mid;
                    }
                    else{
                        l = mid;
                    }
                }
                val[v] += r;
                seg[v] = {now, now + val[v] - 1};
                now += val[v];

            }
            int sum = 0;
            for (auto to : sz[i]){
                sum += val[to];
            }
            if (sum > mx){
                assert(0);
            }
            seg[sz[i].back()].second = mx;
            q.pb(i - 1);
            q.pb(i + 1);
        }
        else if (i - 1 >= 0 && good[i - 1]){
            int now = 1;
            for (auto v : sz[i]){
                int l = -1, r = n + 1;
                while(r - l > 1){
                    int mid = (r + l) / 2;
                    bool x = 0;
                    for (auto to : g[v]){
                        if (!merge(now, now + val[v] + mid - 1, seg[to].first, seg[to].second)){
                            x = 1;
                        }
                    }
                    if (!x){
                        r = mid;
                    }
                    else{
                        l = mid;
                    }
                }
                val[v] += r;
                seg[v] = {now, now + val[v] - 1};
                now += val[v];
            }
            int sum = 0;
            for (auto to : sz[i]){
                sum += val[to];
            }
            if (sum > mx){
                assert(0);
            }
            seg[sz[i].back()].second = mx;
            q.pb(i - 1);
            q.pb(i + 1);
        }
    }
    cout << w << ' ' << mx << endl;
    for (int i = 0; i < w; i++){
        sort(sz[i].begin(), sz[i].end());
        cout << sz[i].size() << ' ';
        for (auto to : sz[i]){
            cout << to + 1 << ' ' << val[to] << ' ';
        }
        cout << endl;
    }
    return 0;
}
