#include<bits/stdc++.h>

using namespace std;

#define int long long
#define ld long double
#define ll long long
#define pb push_back

mt19937 rnd(51);

const int INF = 1e18;

int mul(int a, int b){
    ld c = log2(a) + log2(b);
    if (c > log2(INF)){
        return INF;
    }
    else{
        return a * b;
    }
}

int binpow(int a, int n){
    int res = 1;
    while(n > 0){
        if (n & 1){
            res = mul(res, a);
        }
        a = mul(a, a);
        n /= 2;
    }
    return res;
}

signed main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL
    ios::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    vector<map<vector<int>, int>> a(60);
    for (int i = 1; i <= min(60ll, n); i++){
        if (binpow(2, i) <= 2 * n){
            a[i - 1][{2, 2, n - i}] = 1;
        }
    }
    for (int i = 59; i >= 1; i--){
        for (auto to : a[i]){
            for (int j = to.first[0]; mul(binpow(j, i), to.first[1]) <= 2 * n; j++){
                a[i - 1][{j, mul(j, to.first[1]), to.first[2] + j}] += to.second;
            }
        }
    }
    int ans = 0;
    for (auto to : a[0]){
        if (to.first[1] == to.first[2]){
            ans += to.second;
        }
    }
    cout << ans << endl;
    return 0;
}
