#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
int n, m, h = 0, w = 0;
vector<vector<int>> graph;
vector<int> layer;
vector<int> cnt;
vector<vector<int>> info;
vector<bool> used;
vector<vector<int>> row;
void dfs(int v){
    used[v] = true;
    for(auto e : graph[v]){
        if(!used[e]){
            layer[e] = layer[v] + 1;
            dfs(e);
        }
    }
}
int main() {
    cin >> n >> m;
    cnt.resize(n);
    layer.resize(n);
    graph.resize(n);
    info.resize(n);
    used.resize(n, false);
    for(int i = 0; i < m; i++){
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        cnt[b]++;
        graph[a].emplace_back(b);
    }
    int tp;
    cin >> tp;
    for(int i = 0; i < n; i++)
        if(cnt[i] == 0){
            layer[i] = 1;
            dfs(i);
        }
    for(int i = 0; i < n; i++) {
        h = max(h, layer[i]);
        info[i].emplace_back(layer[i]);
    }
    row.resize(h + 1);
    for(int i = 0; i < n; i++){
        row[layer[i]].emplace_back(i);
    }
    if(tp == 1){
        for(int i = 1; i <= h; i++)
            sort(row[i].begin(), row[i].end());
        for(int i = 1; i <= h; i++){
            for(int j = 0; j < row[i].size(); j++){
                int mx = max(int(graph[row[i][j]].size()), cnt[row[i][j]]);
                info[row[i][j]].emplace_back(mx);
            }
        }
        for(int i = 1; i <= h; i++){
            cout << row[i].size() << " ";
            for(int j = 0; j < row[i].size(); j++){
                cout << row[i][j] + 1 << " " << info[row[i][j]][1] << " ";
            }
            cout << "\n";
        }
    }
    return 0;
}