#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
ll n, m, h = 0, w = 0;
vector<vector<ll>> graph;
vector<ll> layer;
vector<ll> cnt;
vector<vector<ll>> info;
vector<vector<ll>> row;

void dfs(ll v) {
    for (auto e: graph[v]) {
        layer[e] = layer[v] + 1;
        dfs(e);
    }
}

int main() {
    cin >> n >> m;
    cnt.resize(n);
    layer.resize(n);
    graph.resize(n);
    info.resize(n);
    for (int i = 0; i < m; i++) {
        ll a, b;
        cin >> a >> b;
        a--;
        b--;
        cnt[b]++;
        graph[a].emplace_back(b);
    }
    ll tp;
    cin >> tp;
    for (ll i = 0; i < n; i++)
        if (cnt[i] == 0) {
            layer[i] = 1;
            dfs(i);
        }
    for (ll i = 0; i < n; i++) {
        h = max(h, layer[i]);
        info[i].emplace_back(layer[i]);
    }
    row.resize(h + 1);
    for (ll i = 0; i < n; i++) {
        row[layer[i]].emplace_back(i);
    }
    for (ll i = 1; i <= h; i++)
        sort(row[i].begin(), row[i].end());
    for (ll i = h; i >= 1; i--) {
        for (ll j = 0; j < row[i].size(); j++) {
            ll q = row[i][j], q1 = cnt[q];
            if (i == h) {
                if (cnt[row[i][j]] >= 1)
                    info[row[i][j]].emplace_back(cnt[row[i][j]]);
                else
                    info[row[i][j]].emplace_back(1);
            } else {
                ll s = 0, x = 0;
                for (auto e: graph[row[i][j]]) {
                    s += info[e][1];
                    x++;
                }
                if (x <= 1)
                    s = 1;
                info[row[i][j]].emplace_back(s);
            }
        }
    }
    for (ll i = 0; i < row[1].size(); i++)
        w += info[row[1][i]][1];
    for (ll q = 2; q <= h; q++) {
        ll s = 0;
        for (int i = 0; i < row[q].size(); i++)
            s += info[row[q][i]][1];
        w = max(w, s);
    }
    for (ll q = 1; q <= h; q++) {
        ll s = 0;
        for (ll i = 0; i < row[q].size(); i++)
            s += info[row[q][i]][1];
        if (s < w) {
            info[row[q][row[q].size() - 1]][1] += w - s;
        }
    }
    cout << h << " " << w << "\n";
    for (ll i = 1; i <= h; i++) {
        cout << row[i].size() << " ";
        for (ll j = 0; j < row[i].size(); j++) {
            cout << row[i][j] + 1 << " " << info[row[i][j]][1] << " ";
        }
        cout << "\n";
    }
    return 0;
}