#include <stdio.h>
#include <ctype.h>

// O(joemama)

#define MAXN 1000
#define NIL -1

int next[1 + MAXN];
int mod;

int goodperm( int prev ){
  int i, ret = 0, aux;
  
  if( next[0] == NIL )
    return 1;
  
  for( i = 0 ; next[i] != NIL ; i = next[i] ){
    if( next[i] != prev + 1 ){
      aux = next[i];
      next[i] = next[aux];
      ret += goodperm(aux);
      ret %= mod;
      next[i] = aux;
    }
  }
  
  return ret;
}

int main(){
  int n, i, j, k, fact;
  int out;
  
  scanf("%d%d", &n, &mod);

  fact = 1;
  for( i = 0 ; i < n ; i++ ){
    next[i] = i + 1;
    fact = fact * (i + 1);
    fact %= mod;
  }
  next[n] = NIL;
  //printf("%d %d\n", fact, goodperm(-1));
  printf("%d\n", (fact - goodperm(-1) + mod) % mod);

  return 0;
}
