#include <bits/stdc++.h>

#define ll long long
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define pb push_back
#define boost ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define watch(x) cout << (#x) << " = " << x << '\n'

using namespace std;

const int INF = 2e9;
const int N = 2e5 + 128;
vector <int> g[N];
vector <int> inv[N];

vector <int> inLayer(N, INF);

int n, m;
int state;

int mx = 0;

void dfs(int v, int depth) {
    mx = max(mx, depth);
    inLayer[v] = min(depth, inLayer[v]);
    for (auto u : inv[v])
        dfs(u, depth+1);
}

void test_case() {
    cin >> n >> m;
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        --u; --v;
        g[u].pb(v);
        inv[v].pb(u);
    }
    cin >> state;

    for (int i = 0; i < n; i++)
        if (g[i].empty()) {
            inLayer[i] = 0;
            for (auto u : inv[i])
                dfs(u, 1);
        }

    vector < vector<int> > lyr(mx+1);
    for (int i = 0; i < n; i++)
        lyr[inLayer[i]].push_back(i);

    if (state)
        for (int cur = 0; cur <= mx; cur++)
            sort(all(lyr[cur]));
    else {
        vector <int> height(n, 0);
        for (int i = 0; i < n; i++)
            height[i] = inv[i].size();

        for (int cur = 0; cur <= mx; cur++)
            sort(all(lyr[cur]), [&](int x, int y) -> bool {
                return height[x] < height[y];
            });
    }

    vector <int> len(n, 1);
    for (int i = 0; i < mx; i++)
        for (int j = 0; j < (int) lyr[i].size(); j++)
            len[lyr[i][j]] = max(inv[lyr[i][j]].size(), g[lyr[i][j]].size());

    auto add_min = [&](vector<int> vert, int cur) -> void {
        int ans = 0;
        for (int i = 1; i < (int) vert.size() - 1; i++)
            ans += len[vert[i]];
        int ln = (int) vert.size();
        if (ln) ans++;
        if (ln > 1) ans++;
        if (ans == len[cur]) return;
        if (len[cur] < ans) {
            len[cur] = ans;
            return;
        }
        if (ln == 1) {
            len[vert[0]] = len[cur];
            return;
        }
        int addLeft = (len[cur] - ans) / 2;
        int addRight = (len[cur] - ans) / 2 + (len[cur] - ans) % 2;
//        cout << "THERE : " << cur << " " << ln << '\n';
        len[vert[0]] += addLeft;
        len[vert[ln-1]] += addRight;

    };

//    cout << "there\n";
    for (int i = mx-1; i > 0; i--)
        for (int j = 0; j < (int) lyr[i].size(); j++)
            add_min(g[lyr[i][j]], lyr[i][j]);

//    for (int i = mx-1; i >= 0; i--) {
//        cout << "layer : " << i << '\n';
//        for (auto c : lyr[i])
//            cout << "c : " << c << " len[c] : " << len[c] << ' ';
//        cout << '\n';
//    }

    auto calc_root = [&](vector <int> vert, int cur) -> void {
        int ans = 0;
//        watch(cur);
        for (int i = 1; i < (int) vert.size() - 1; i++) {
//            watch("ans += "); watch(len[vert[i]]);
            ans += len[vert[i]];
        }
//        cout << cur+1 << ' ';
//        for (auto c : vert) {
//            cout << c+1 << ' ';
//        }
        int ln = (int) vert.size();
        if (ln) ans++;
        if (ln > 1) ans++;
//        watch(ans);
        len[cur] = ans;
    };

    for (auto c : lyr[mx])
        calc_root(g[c], c);

    ll total_len = INF;
    for (int i = 0; i <= mx; i++) {
        ll lengts = 0ll;
        for (auto c : lyr[0])
            lengts += len[c];
        total_len = min(lengts, total_len);
    }

    cout << mx+1 << ' ' << total_len << '\n';
    for (int i = mx; i >= 0; i--) {
        cout << lyr[i].size() << ' ';
        for (auto c : lyr[i])
            cout << c + 1 << ' ' << len[c] << ' ';
        cout << '\n';
    }

}

main () {
//    boost;
    test_case();
    return 0;
}
