#include <iostream>
#include <string>
#include <set>
#include <vector>
#include <map>
#include <algorithm>
using namespace std;

typedef long long ll;
typedef long double ld;
#define ff first
#define ss second

ll n, l, r, d, m;
ll cnt = 0;
map<int, vector<int>>tak, vra;
vector<set<int>>p;
vector<vector<int>>tbl;
map<int, int>ds;
ll mx_tbl = 0, mx_ind, cur_tbl = 0;
int bl;

int main()
{
	cin >> n >> m;
	for (int i = 0; i < m; i++) {
		int x, y;
		cin >> x >> y;
		tak[x].push_back(y);
		vra[y].push_back(x);
	}
	cin >> bl;
	p.push_back({});
	for (int i = 1; i <= n; i++) {
		sort(tak[i].begin(), tak[i].end());
		sort(vra[i].begin(), vra[i].end());
		if (vra[i].size() == 0) {
			p[0].insert(i);
		}
	}
	int curt = 0;
	while (p[curt].size() != 0) {
		p.push_back({});
		for (auto x : p[curt]) {
			for (int i = 0; i < tak[x].size(); i++) {
				p[curt + 1].insert(tak[x][i]);
			}
		}
		curt++;
	}
	d = p.size() - 1;
	for (int i = 0; i < d; i++) {
		tbl.push_back({});
		for (auto x : p[i]) {
			tbl[i].push_back({ x });
			ds[x] = max(tak[x].size(), vra[x].size());
			cur_tbl += max(tak[x].size(), vra[x].size());
		}
		if (mx_tbl < cur_tbl) {
			mx_tbl = cur_tbl;
			mx_ind = i;
		}
		cur_tbl = 0;
	}
	for (int i = 1; i < d; i++) {
		for (int j = 0; j < tbl[i].size(); j++) {
			ds[tbl[i][j]] = 0;
			for (int k = 0; k < vra[tbl[i][j]].size(); k++) {
				ds[tbl[i][j]] += ds[vra[tbl[i][j]][k]];
			}
			if (j != 0) {
				ds[tbl[i][j]] -= ds[vra[tbl[i][j]][0]];
				ds[tbl[i][j]]++;
			}
			if (j != tbl[i].size() - 1) {
				ds[tbl[i][j]] -= ds[vra[tbl[i][j]][vra[tbl[i][j]].size() - 1]];
				ds[tbl[i][j]]++;
			}
			if (vra[tbl[i][j]].size() == 1) {
				ds[tbl[i][j]] = 1;
			}
		}
	}
	for (int i = 1; i < d; i++) {
		for (int j = 0; j < tbl[i].size(); j++) {
			ds[tbl[i][j]] = 0;
			for (int k = 0; k < vra[tbl[i][j]].size(); k++) {
				ds[tbl[i][j]] += ds[vra[tbl[i][j]][k]];
			}
			if (j != 0) {
				ds[tbl[i][j]] -= ds[vra[tbl[i][j]][0]];
				ds[tbl[i][j]]++;
			}
			if (j != tbl[i].size() - 1) {
				ds[tbl[i][j]] -= ds[vra[tbl[i][j]][vra[tbl[i][j]].size() - 1]];
				ds[tbl[i][j]]++;
			}
			if (vra[tbl[i][j]].size() == 1) {
				ds[tbl[i][j]] = 1;
			}
		}
	}
	for (int i = 1; i < d; i++) {
		for (int j = 0; j < tbl[i].size(); j++) {
			ds[tbl[i][j]] = 0;
			for (int k = 0; k < vra[tbl[i][j]].size(); k++) {
				ds[tbl[i][j]] += ds[vra[tbl[i][j]][k]];
			}
			if (j != 0) {
				ds[tbl[i][j]] -= ds[vra[tbl[i][j]][0]];
				ds[tbl[i][j]]++;
			}
			if (j != tbl[i].size() - 1) {
				ds[tbl[i][j]] -= ds[vra[tbl[i][j]][vra[tbl[i][j]].size() - 1]];
				ds[tbl[i][j]]++;
			}
			if (vra[tbl[i][j]].size() == 1) {
				ds[tbl[i][j]] = 1;
			}
		}
	}
	for (int i = d - 2; i >= 0; i--) {
		for (int j = 0; j < tbl[i].size(); j++) {
			ds[tbl[i][j]] = 0;
			for (int k = 0; k < tak[tbl[i][j]].size(); k++) {
				ds[tbl[i][j]] += ds[tak[tbl[i][j]][k]];
			}
			if (j != 0) {
				ds[tbl[i][j]] -= ds[tak[tbl[i][j]][0]];
				ds[tbl[i][j]]++;
			}
			if (j != tbl[i].size() - 1) {
				ds[tbl[i][j]] -= ds[tak[tbl[i][j]][tak[tbl[i][j]].size() - 1]];
				ds[tbl[i][j]]++;
			}
			if (tak[tbl[i][j]].size() == 1) {
				ds[tbl[i][j]] = 1;
			}
		}
	}
	for (int i = d - 2; i >= 0; i--) {
		for (int j = 0; j < tbl[i].size(); j++) {
			ds[tbl[i][j]] = 0;
			for (int k = 0; k < tak[tbl[i][j]].size(); k++) {
				ds[tbl[i][j]] += ds[tak[tbl[i][j]][k]];
			}
			if (j != 0) {
				ds[tbl[i][j]] -= ds[tak[tbl[i][j]][0]];
				ds[tbl[i][j]]++;
			}
			if (j != tbl[i].size() - 1) {
				ds[tbl[i][j]] -= ds[tak[tbl[i][j]][tak[tbl[i][j]].size() - 1]];
				ds[tbl[i][j]]++;
			}
			if (tak[tbl[i][j]].size() == 1) {
				ds[tbl[i][j]] = 1;
			}
		}
	}
	for (int i = d - 2; i >= 0; i--) {
		for (int j = 0; j < tbl[i].size(); j++) {
			ds[tbl[i][j]] = 0;
			for (int k = 0; k < tak[tbl[i][j]].size(); k++) {
				ds[tbl[i][j]] += ds[tak[tbl[i][j]][k]];
			}
			if (j != 0) {
				ds[tbl[i][j]] -= ds[tak[tbl[i][j]][0]];
				ds[tbl[i][j]]++;
			}
			if (j != tbl[i].size() - 1) {
				ds[tbl[i][j]] -= ds[tak[tbl[i][j]][tak[tbl[i][j]].size() - 1]];
				ds[tbl[i][j]]++;
			}
			if (tak[tbl[i][j]].size() == 1) {
				ds[tbl[i][j]] = 1;
			}
		}
	}
	cout << d << " " << mx_tbl << endl;
	for (int i = 0; i < d; i++) {
		cout << tbl[i].size() << " ";
		for (int j = 0; j < tbl[i].size(); j++) {
			cout << tbl[i][j] << " " << ds[tbl[i][j]] << " ";
		}
		cout << endl;
	}
}