#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <iomanip>
#include <cstdio>
#include <stdio.h>
#include <cstdlib>
#include <stdlib.h>
#include <array>
#include <string>
#include <cstring>
#include <algorithm>
#include <cmath>
#include <math.h>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <vector>
#include <stack>
#include <queue>
#include <deque>
#include <tuple>
#include <ctime>
#include <time.h>
#include <climits>
#include <limits.h>
#include <cassert>
#include <assert.h>
#include <random>
#include <utility>
#include <chrono>
#include <fstream>
using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef double db;
typedef long double ld;

#define pr pair
#define mpr make_pair
#define ff first
#define ss second

#define mset multiset
#define mmap multimap
#define uset unordered_set
#define umap unordered_map
#define umset unordered_multiset
#define ummap unordered_multimap
#define pqueue priority_queue

#define sz(x) (x).size()
#define len(x) (x).length()
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define clr(x) (x).clear()

#define lb lower_bound
#define ub upper_bound
#define bs binary_search

void fastio()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	return;
}

void precision(int x)
{
	cout.setf(ios::fixed | ios::showpoint);
	cout.precision(x);
	return;
}

ll binpow(ll a, int b)
{
	ll ans = 1;
	while (b) {
		if ((b & 1) == 1) {
			ans *= a;
		}
		b >>= 1;
		a *= a;
	}
	return ans;
}

ll binpow_by_mod(ll a, ll b, ll mod)
{
	ll ans = 1;
	while (b) {
		if ((b & 1) == 1) {
			ans *= a;
			ans %= mod;
		}
		b >>= 1;
		a *= a;
		a %= mod;
	}
	return ans;
}

ll factorial(int a)
{
	int i;
	ll ans = 1;
	for (i = 1; i <= a; i++) {
		ans *= ll(i);
	}
	return ans;
}

ll factorial_by_mod(int a, ll mod)
{
	int i;
	ll ans = 1;
	for (i = 1; i <= a; i++) {
		ans *= ll(i);
		ans %= mod;
	}
	return ans;
}

// ------------------- SOLUTION ------------------------------ //

/*const int N = 200005;
int a[N];
int n;*/

ll n;

ll f(int x, ll s, ll mult, ll sum)
{
	//cout << x << ' ' << s << ' ' << mult << ' ' << sum << endl;
	int i, j;
	if (x == 1) {
		if (sum % (mult - 1) == 0) {
			if (sum >= s * (mult - 1)) {
				return 1;
			}
			else {
				return 0;
			}
		}
		else {
			return 0;
		}
	}
	ll k;
	ll ans = 0;
	for (k = s; binpow(k, x) <= (n / mult) * 2LL; k++) {
		ans += f(x - 1, k, mult * k, sum + k);
	}
	return ans;
}

void solve()
{
	int i, j;
	cin >> n;
	ll ans = 0;
	for (i = 2; i <= int(min(35LL, n)); i++) {
		ans += f(i, 2, 1, n - i);
	}
	cout << ans << endl;
	return;
}

void precalc()
{
	return;
}

int main()
{
	fastio();

	precalc();

	int tests = 1, tc;
	//cin >> tests;
	for (tc = 1; tc <= tests; tc++) {
		solve();
	}
	return 0;
}