#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;
using ll = long long;

ll ans_dumb(ll n) {
    vector<int> v(n);
    for (int i = 0; i < n; ++i)
        v[i] = i;
    vector<int> cv = v;
    ll ans = 0;
    do {
        bool ok = false;
        for (int i = 0; i + 1 < n; ++i) {
            if (v[i + 1] == v[i] + 1)
                ok = true;
        }
        if (ok)
            ++ans;
        next_permutation(v.begin(), v.end());
    } while (cv != v);
    return ans;
}

signed main() {
    ll n, mod;
    cin >> n >> mod;
    if (n == 1) {
        cout << 0 << endl;
        return 0;
    }
    ll add = 0;
    ll x = 1;
    ll n0_start = 2;
    if (n >= mod * 2 + 8) {
        ll cnt = (n - 6) / mod;
        n0_start = cnt * mod + 1;
        if (mod % 2 == 0 || (mod % 2 == 1 && cnt % 2 == 0)) {
            x = mod - 1;
            add = 1;
        } else {
            x = 1;
            add = mod - 1;
        }
    }
    for (ll n0 = n0_start; n0 < n; ++n0) {
        ll n0_ = n0 % mod;
        x = (x * (n0_ + 1) + add) % mod;
        add *= n0_;
        if (n0 % 2 == 0)
            ++add;
        else
            --add;
        add = ((add % mod) + mod) % mod;
        //cout << n0 << ' ' << n << endl;
    }
    cout << x << endl;
}
