#include <iostream>
#include <map>
#include <vector>
using namespace std;
using ll = long long;

const ll INF = 1e9;

ll mod(ll a, ll m) {
    return (m + (a % m)) % m;
}

ll timer = 0;

ll brute_force(ll freecnt, ll mxvl, ll sm, ll prod) {
    if (prod > freecnt + sm)
        return 0;
    if (prod == freecnt + sm)
        return 1;
    if (freecnt == 0)
        return 0;

    ll p = mod(-(sm + freecnt), prod);
    if (prod * p >= sm + freecnt + 10)
        return 0;
    ll ans = 0;
    for (ll k = 2; k <= mxvl; ++k) {
        if (prod * k > freecnt + sm + k)
            break;
        --p;
        ans += brute_force(freecnt - 1, k, sm + k, prod * k);
    }
    return ans;
}

ll get_ans(ll n) {
    return brute_force(n, n + 10, 0, 1);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll n;
    cin >> n;
    cout << get_ans(n) << endl;
    return 0;
    for (int n0 = 2; n0 <= n; ++n0) {
        cout << get_ans(n0) << ' ';
    }
    cout << endl;
}
