#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>

using std::cin;
using std::vector;

typedef long long ll;

ll result = 0;
ll n, m;
vector<bool> used;
vector<ll> fact;

void recur(ll ost, ll pred)
{
    if (ost == 0)
    {
        return;
    }
    for (ll i = 0; i < n; ++i)
    {
        if (!used[i])
        {
            if (i == pred + 1)
            {
                result += fact[ost - 1];
                if (result > m)
                    result %= m;
            }
            else
            {
                used[i] = true;
                recur(ost - 1, i);
                used[i] = false;
            }
        }
    }
}

int main()
{
    std::ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n >> m;
    used.resize(n);
    fact.resize(21);
    fact[0] = 1;
    for (ll i = 1; i <= 20; ++i)
    {
        fact[i] = fact[i - 1] * i;
    }
    vector<ll> pw2(21);
    pw2[0] = 1;
    for (ll i = 1; i <= 20; ++i)
    {
        pw2[i] = pw2[i - 1] * 2;
    }
    ll p = pw2[n];
    vector<vector<ll>> dp(p, vector<ll>(n));
    ll tekpw = n - 1;
    ll ost = 1;
    for (ll mask = p - 2; mask >= 0; --mask)
    {
        ost = n - __builtin_popcount(mask);
        for (ll pred = 0; pred < n; ++pred)
        {
            if ((mask >> (n - pred - 1)) & 1)
            {
                for (ll i = 0; i < n; ++i)
                {
                    if (!((mask >> (n - i - 1)) & 1))
                    {
                        if (i == pred + 1)
                        {
                            dp[mask][pred] += fact[ost - 1];
                            if (dp[mask][pred] > m)
                                dp[mask][pred] %= m;
                        }
                        else
                        {
                            ll newmask = mask | (1 << (n - i - 1));
                            dp[mask][pred] += dp[newmask][i];
                            dp[mask][pred] %= m;
                        }
                    }
                }
            }
        }
    }
    //recur(n, -2);
    std::cout << dp[0][n - 1] << '\n';
    return 0;
}