#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <unordered_map>

#pragma gcc optimize("Ofast");
#pragma gcc unroll-loops;
#pragma gcc optimize("O3");

using std::cin;
using std::vector;
using std::unordered_map;

typedef long long ll;

ll result = 0;
ll n, m;
ll mask = 0;
vector<ll> fact;
unordered_map<ll, unordered_map<ll, ll>> cache;

ll recur(ll ost, ll pred)
{
    ll result = 0;
    if (ost == 0)
    {
        return 0;
    }
    if (cache.count(mask) && cache[mask].count(pred))
        return cache[mask][pred];
    for (ll i = 0; i < n; ++i)
    {
        if (!((mask >> (n - i - 1)) & 1))
        {
            if (i == pred + 1)
            {
                result += fact[ost - 1];
                if (result > m)
                    result %= m;
            }
            else
            {
                ll maskc = mask;
                mask = mask | (1 << (n - i - 1));
                result += recur(ost - 1, i);
                if (result > m)
                    result %= m;
                mask = maskc;
            }
        }
    }
    if (!cache.count(mask))
    {
        cache[mask] = unordered_map<ll, ll>();
    }
    cache[mask][pred] = result;
    return result;
}

int main()
{
    std::ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n >> m;
    fact.resize(21);
    fact[0] = 1;
    for (ll i = 1; i <= 20; ++i)
    {
        fact[i] = fact[i - 1] * i;
    }
    //vector<ll> pw2(21);
    //pw2[0] = 1;
    //for (ll i = 1; i <= 20; ++i)
    //{
        //pw2[i] = pw2[i - 1] * 2;
    //}
    //ll p = pw2[n];
    //vector<vector<ll>> dp(p, vector<ll>(n));
    //ll tekpw = n - 1;
    //ll ost = 1;
    /*
    for (ll mask = p - 2; mask >= 0; --mask)
    {
        ost = n - __builtin_popcount(mask);
        for (ll pred = 0; pred < n; ++pred)
        {
            if ((mask >> (n - pred - 1)) & 1)
            {
                for (ll i = 0; i < n; ++i)
                {
                    if (!((mask >> (n - i - 1)) & 1))
                    {
                        if (i == pred + 1)
                        {
                            dp[mask][pred] += fact[ost - 1];
                            if (dp[mask][pred] > m)
                                dp[mask][pred] %= m;
                        }
                        else
                        {
                            ll newmask = mask | (1 << (n - i - 1));
                            dp[mask][pred] += dp[newmask][i];
                            dp[mask][pred] %= m;
                        }
                    }
                }
            }
        }
    }
    */
    std::cout << recur(n, -2) << '\n';
    return 0;
}