#include <bits/stdc++.h>
#define MN 207171

using namespace std;
int n, m, D[MN], Lat[MN];
vector<int> L[MN], Par[MN];
int curw = 0, maxw = 0, linmax = 0;

int maxh;
vector<int> Inaltime[MN];
void dfs(int u) {
    if(D[u]) return;
    D[u] = 1;
    for(auto it : L[u]){
        if(!D[it]) dfs(it);
        D[u] = max(D[u], D[it] + 1);
    }
    maxh = max(maxh, D[u]);
    Inaltime[D[u]].push_back(u);
}

void propagam() {
    int lungime = 0;
    for(int i = maxh - 1; i >= 1; --i) {
        ///incepem invers si dam valori fiilor, apoi propagam in sus de la fii
        for(auto it : Inaltime[i]){
            ///pentru nodul it, toti parintii inafara de primul si ultimul il vor afecta
            lungime = 0;
            for(auto p : Par[it]){
                if((p == *Par[it].begin()) || p == *Par[it].rbegin()) ++lungime;
                else lungime += Lat[p];
            }
            Lat[it] = max(lungime, Lat[it]);
        }
    }
    for(int i = 2; i <= maxh; ++i) {//propagam in sus
        for(auto it : Inaltime[i]){
            ///pentru nodul it, toti parintii inafara de primul si ultimul il vor afecta
            lungime = 0;
            for(auto p : L[it]){
                if((p == *L[it].begin()) || p == *L[it].rbegin()) ++lungime;
                else lungime += Lat[p];
            }
            Lat[it] = max(lungime, Lat[it]);
        }
    }
}
int ST[MN], DR[MN];

void save_line(int lin) {
    for(int i = 1; i < Inaltime[lin].size(); ++i) {
        ST[Inaltime[lin][i]] = DR[ST[Inaltime[lin][i-1]]]+1;
        DR[Inaltime[lin][i]] = ST[Inaltime[lin][i]] + Lat[Inaltime[lin][i]] - 1;
    }
}

void propag_jos(int lin) {
    int ult_dr = 0, parid = 0, nwi;
    for(auto it : Inaltime[lin-1]) {
        //linia lin este fixa, trebuie sa vedem ce se intampla aici
        ST[it] = ult_dr+1;
        while(ST[it] + Lat[it] <= ST[*Par[it].rbegin()]) ++Lat[it];
        DR[it] = Lat[it] + ST[it] - 1;
        ult_dr = DR[it];
    }
    while(DR[*Inaltime[lin-1].rbegin()] < maxw) {
        ++Lat[*Inaltime[lin-1].rbegin()];
        ++DR[*Inaltime[lin-1].rbegin()];
    }
}
void propag_sus(int lin) {
    int ult_dr = 0, parid = 0, nwi;
    for(auto it : Inaltime[lin+1]) {
        //linia lin este fixa, trebuie sa vedem ce se intampla aici
        ST[it] = ult_dr+1;
        while(ST[it] + Lat[it] <= ST[*L[it].rbegin()]) ++Lat[it];
        DR[it] = Lat[it] + ST[it] - 1;
        ult_dr = DR[it];
    }
    while(DR[*Inaltime[lin+1].rbegin()] < maxw) {
        ++Lat[*Inaltime[lin+1].rbegin()];
        ++DR[*Inaltime[lin+1].rbegin()];
    }
}

int main() {
    cin >> n >> m;
    int u, v;
    for(int i = 1; i <= m; ++i) {
        cin >> u >> v;
        L[u].push_back(v);
        Par[v].push_back(u);
    }
    int ok;cin >> ok;
    for(int i = 1; i <= n; ++i)
        if(!D[i]) dfs(i);
    for(int i = 0; i <= maxh; ++i) sort(Inaltime[i].begin(), Inaltime[i].end());
    ///in inaltime[i] avem toate nodurile de inaltime i
    for(int i = maxh; i >= 1; --i) { ///valori init
        for(auto it : Inaltime[i]) Lat[it] = max(1, (int)max(L[it].size(), Par[it].size()));
    }
    propagam();
    for(int i = 1; i <= maxh; ++i) {
        curw = 0;
        for(auto it : Inaltime[i]) curw += Lat[it];
        if(curw > maxw) {
            maxw = curw;
            linmax = i;
        }
    }
    for(int i = linmax; i > 1; --i) propag_jos(i);
    for(int i = linmax; i < maxh; ++i)propag_sus(i);
    for(int i = linmax; i > 1; --i) propag_jos(i);
    for(int i = linmax; i < maxh; ++i)propag_sus(i);
    propagam();
    for(int i = 1; i <= maxh; ++i) {
        curw = 0;
        for(auto it : Inaltime[i]) curw += Lat[it];
        if(curw > maxw) {
            maxw = curw;
            linmax = i;
        }
    }
    for(int i = linmax; i > 1; --i) propag_jos(i);
    for(int i = linmax; i < maxh; ++i)propag_sus(i);
    for(int i = linmax; i > 1; --i) propag_jos(i);
    for(int i = linmax; i < maxh; ++i)propag_sus(i);
    cout << maxh << " " << maxw << "\n";
    save_line(linmax);
    for(int i = maxh; i >= 1; --i) {
        cout << Inaltime[i].size() << " ";
        for(auto it : Inaltime[i]) cout << it << " " << Lat[it] << " ";
        cout << "\n";
    }
    return 0;
}
