#include <bits/stdc++.h>

#define ll long long
#define pb push_back

using namespace std;

const ll maxn = 2 * 1e5 + 5;

ll n, m, h, w;
ll cnt[maxn], width[maxn], visited[maxn], pref[maxn], add[maxn], npref[maxn];
vector<ll> g[maxn], l[maxn], ans[maxn];
void dfs(int v, ll len = 1){
    l[len].pb(v);
    width[v] = max((ll)g[v].size(), cnt[v]);
    h = max(h, len);
    visited[v] = 1;
    for (auto to : g[v]){
        if (visited[to] == 0){
            dfs(to, len + 1);
        }
    }
}
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
    cin >> n >> m;
    for (int i = 1; i <= m; ++i){
        int u, v;
        cin >> u >> v;
        g[u].pb(v);
        cnt[v]++;
    }
    int k;
    cin >> k;
    for (int i = 1; i <= n; ++i){
        if (cnt[i] == 0){
            dfs(i);
        }
    }
    for (int i = 1; i <= h; ++i){
        ll cursum = 0, prevadd = 0;
        for (int j = 0; j < l[i].size(); ++j){
            ll x = l[i][j];
            ll wq = width[x];
            if (pref[cursum + wq - prevadd] > 0){
                wq++;
                add[pref[cursum + wq - prevadd]]++;
           //     cout << "ok\n";
            }
            cursum += wq;
            ans[i].pb(wq);
            npref[cursum] = x;
        }
        cursum = 0;
        for (int j = 0; j < l[i].size(); ++j){
            cursum += ans[i][j];
            pref[cursum] = npref[cursum];
            npref[cursum] = 0;
        }
    }
    for (int i = 1; i <= h; ++i){
        ll cs = 0, pos = 0;
        for (auto it : l[i]){
            cs += ans[i][pos++] + add[it];
        }
        w = max(w, cs);
    }
    cout << h << " " << w << '\n';
    for (int i = 1; i <= h; ++i){
        cout << l[i].size() << " ";
        ll pos = 0;
        for (auto it : l[i]){
            cout << it << " " << ans[i][pos++] + add[it] << " ";
        }
        cout << '\n';
    }
}
