#include<bits/stdc++.h>
typedef long long ll;

using namespace std;

ll sum(ll a, ll b, ll m) {
	if (a + b >= m) {
		return a + b - m;
	}
	return a + b;
}

ll sub(ll a, ll b, ll m) {
	if (a - b < 0) {
		return a - b + m;
	}
	return a - b;
}

ll mul(ll a, ll b, ll m) {
	return a * b % m;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	ll n, m;
	cin >> n >> m;
	if (n == 1) {
		cout << 0;
		return 0;
	}
	ll ans = n;
	vector<vector<ll>> dp(n + 1, vector<ll>(n, 0));
	dp[0][0] = 1;
	dp[1][0] = 1;
	dp[2][0] = 1;
	dp[2][1] = 1;
	for (ll i = 2; i < n; i++) {
		ans = mul(ans, i, m);
		for (ll j = 0; j < i; j++) {
			dp[i + 1][j] += mul(dp[i][j], i - j, m);
			dp[i + 1][j + 1] += dp[i][j];
			dp[i + 1][j - 1] += mul(dp[i][j], j, m);
		}
	}
	cout << sub(ans, dp[n][0], m);
}
