#include<bits/stdc++.h>
typedef long long ll;

using namespace std;

ll sum(ll a, ll b, ll m) {
	if (a + b >= m) {
		return a + b - m;
	}
	return a + b;
}

ll sub(ll a, ll b, ll m) {
	if (a - b < 0) {
		return a - b + m;
	}
	return a - b;
}

ll mul(ll a, ll b, ll m) {
	return a * b % m;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	ll n, m;
	cin >> n >> m;
	vector<vector<ll>> sons(n), parents(n);
	for (ll i = 0; i < m; i++) {
		ll a, b;
		cin >> a >> b;
		a--;
		b--;
		sons[a].push_back(b);
		parents[b].push_back(a);
	}
	ll x;
	cin >> x;
	vector<ll> dist(n, -1);
	queue<ll> q;
	for (ll i = 0; i < n; i++) {
		if (parents[i].size() == 0) {
			q.push(i);
			dist[i] = 0;
		}
	}
	vector<vector<ll>> arr;
	while (!q.empty()) {
		ll now = q.front();
		if (arr.size() <= dist[now]) {
			arr.push_back(vector<ll>(0, 0));
		}
		arr.back().push_back(now);
		q.pop();
		for (auto i : sons[now]) {
			if (dist[i] == -1) {
				dist[i] = dist[now] + 1;
				q.push(i);
			}
		}
	}
	for (auto& i : arr) {
		sort(i.begin(), i.end());
	}
	for (auto& i : sons) {
		sort(i.begin(), i.end());
	}
	for (auto& i : parents) {
		sort(i.begin(), i.end());
	}
	vector<ll> dp(n, 1);
	bool b = true;
	while (b) {
		vector<ll> nv = dp;
		b = false;
		for (auto& i : arr) {
			for (auto j : i) {
				ll now = 0;
				for (auto k : sons[j]) {
					ll nn = max(0ll, nv[k] - (ll)parents[k].size()) + 1;
					nv[k] -= nn;
					now += nn;
				}
				if (dp[j] < now) {
					dp[j] = now;
					b = true;
				}
			}
		}
		nv = dp;
		//reverse(arr.begin(), arr.end());
		//swap(sons, parents);
		for (auto& i : arr) {
			for (auto j : i) {
				ll now = 0;
				for (auto k : sons[j]) {
					ll nn = max(0ll, nv[k] - (ll)parents[k].size()) + 1;
					nv[k] -= nn;
					now += nn;
				}
				if (dp[j] < now) {
					dp[j] = now;
					b = true;
				}
			}
		}
		//reverse(arr.begin(), arr.end());
		//swap(sons, parents);
	}
	ll ah = 0;
	for (auto j : arr[0]) {
		ah += dp[j];
	}
	cout << arr.size() << ' ' << ah << '\n';
	for (auto& i : arr) {
		cout << i.size() << ' ';
		for (auto j : i) {
			cout << j + 1 << ' ' << dp[j] << ' ';
		}
		cout << '\n';
	}
}
