#pragma GCC optimize("O3")
#pragma GCC target("avx2")
#include <bits/stdc++.h>
using namespace std;
#define ll long long
#define f first
#define s second
#define veci vector <int>
#define pb push_back
#define mp make_pair
#define all(_v) _v.begin(), _v.end()
#define sz(_v) (int)_v.size()

ll n;
int m;

int mul(int a, int b) {
    return a * 1ll * b % m;
}

void add(int &a, int b) {
    a += b;
    if(a >= m) a -= m;
    if(a < 0) a += m;
}

int sum(int a, int b) {
    add(a, b);
    return a;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m;
    if(n > 1e6) {
        cout << 0;
        return 0;
    }
    veci dp1(n + 1), dp2(n + 1);
    dp2[0] = 1;
    int ans = 1;
    for(int i = 2; i <= n; ++i) {
        dp2[i] = mul(i - 1, sum(dp2[i - 1], dp2[i - 2]));
        ans = mul(ans, i);
    }
    cout << sum(ans, -sum(dp2[n], dp2[n - 1]));
    return 0;
}
