#include <bits/stdc++.h>

#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx2")

using namespace std;

#define F first
#define S second
#define sz size()
#define all(x) x.begin(), x.end()
#define pb push_back

typedef vector < int > vi;
typedef vector < vi > vvi;
typedef pair < int, int > pii;

const int N = 2e5 + 10;
vvi g(N), ans(N), stone(N);
int up[N], down[N], d[N], used[N], _sz[N], pref[N], num[N];
set < pii > s[N];

void dfs (int v) {
    used[v] = 1;
    d[v] = 1;
    for (auto i : g[v]) {
        if (!used[i]) {
            dfs (i);
        }
        d[v] = max(d[v], d[i] + 1);
    }
}


void dfs2 (int v, int pr) {
    used[v] = 1;
    int sum = 0;
    for (int j = 0; j + 1 < g[v].sz; j++) {
        int i = g[v][j];
        if (!used[i]) {
            dfs2(i, v);
        }
        else {
            if (pref[d[i]] == pref[d[v]]) {
                _sz[i]++;
                pref[d[i]]++;
            }
        }
        sum += d[i];
    }
    if(g[v].sz == 0) {
        _sz[v] = 1;
        pref[d[v]]++;
        return;
    }
    int i = g[v].back();
    int cur = pref[d[v]];
    int nxt = pref[d[i]];
    if (!used[i]) {
        dfs2(i, v);
    }
    else {
        sum += _sz[i];
        if (pref[d[i]] - sum  == cur) {
            _sz[i]++;
            pref[d[i]]++;
        }
    }
    cur = pref[d[v]];
    nxt = pref[d[i]];
    int sz_last = _sz[i];
    int my_sz;
    ///last -> закрыть до конца
    if (stone[d[v]].back() == v) {
        my_sz = nxt - cur;
    }
    else {
        int next_ver = stone[d[v]][num[v] + 1];
        if (g[next_ver][0] != i) {
            ///закрыть до конца
             my_sz = nxt - cur;
             /*if (v == 5) {
                cout << my_sz << "\n";
             }*/
        }
        else {
            ///закрыть минимально
            my_sz = max(1, nxt - sz_last + 1 - cur);
        }
    }
    //cout << v << " " << _sz[v] << " " << my_sz << " " << cur << " " << nxt << "\n";
    _sz[v] = my_sz;
    pref[d[v]] += _sz[v];
}

signed main() {
    int n, m;
    cin >> n >> m;
    for (int i = 1; i <= m; i++) {
        int u, v;
        cin >> u >> v;
        up[u]++;
        down[v]++;
        g[u].pb(v);
    }
    int val;
    cin >> val;
    for (int i = 1; i <= n; i++) {
        if (!used[i]){
            dfs (i);
        }
    }

    int h = 0, w = 0;
    for (int i = 1; i <= n; i++) {
        //cout << d[i] << " ";
        h = max(h, d[i]);
        stone[d[i]].pb(i);
    }
    if (val == 0) {
        cout << -1;
        return 0;
    }
    for (int i = 1; i <= h; i++) {
        sort(all(stone[i]));
    }
    for (int i = 1; i <= h; i++) {
        for (int j = 0; j < stone[i].sz; j++) {
            num[stone[i][j]] = j;
        }
    }
    for (int i = 1; i <= n; i++) {
        sort (all(g[i]));
        used[i] = 0;
    }
    for (int i = 0; i < stone[h].sz; i++) {
        int ver = stone[h][i];
        dfs2 (ver, ver);
    }

    for (int i = 1; i <= h; i++) {
        w = max(w, pref[i]);
    }

    cout << h << " "<< w << "\n";
    for (int i = h; i >= 1; i--) {
        cout << stone[i].sz << " ";
        for (int j = 0; j + 1 < stone[i].sz; j++) {
            cout << stone[i][j] << " " << _sz[stone[i][j]] << " ";
        }
        cout << stone[i].back() << " " << _sz[stone[i].back()] + w - pref[d[stone[i].back()]];
        cout << "\n";
    }
}

/*
15 15
1 4
1 5
2 5
2 6
3 6
3 7
4 8
4 9
4 10
5 10
5 11
5 12
6 13
6 14
7 15
1
*/
