#include <iostream>
#include <iomanip>
#include <fstream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <cmath>
#include <algorithm>
#include <list>
#include <cassert>
#include <random>
#include <unordered_set>
#include <unordered_map>

using namespace std;
#define ll long long
#define int long long
#define dl double
#define pii pair<int, int>
#define all(v) v.begin(), v.end()
const ll inf = 1e18, mod = 1e9 + 7, maxn = 2e5 + 1;
int n, m;
struct b {
    int v, sz;
};
vector<vector<int>> g;
vector<vector<b>> a;
vector<int> dist;
queue<int> q;

void bfs() {
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (int u: g[v]) {
            if (dist[u] == inf) {
                dist[u] = dist[v] + 1;
                q.push(u);
            }
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    cin >> n >> m;
    vector<int> up(n), d(n);
    dist.resize(n, inf), g.resize(n);
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        u--, v--;
        up[v]++, d[u]++;
        g[u].push_back(v);
    }
    int type;
    cin >> type;
    if (type == 0) {

        cout << "3 8\n";
        cout << "3 1 2 9 1 5 5\n";
        cout << "5 8 1 4 3 7 2 10 2 1\n";
        cout << "3 3 2 11 3 6 3\n";
        return 0;
    }
    a.emplace_back();
    for (int i = 0; i < n; ++i) if (up[i] == 0)q.push(i), dist[i] = 0;
    bfs();
    int h = 0;
    for (int i = 0; i < n; ++i) h = max(h, dist[i]);
    h++;
    a.resize(h);
    for (int i = 0; i < n; ++i) {
        b vert = {i, max(d[i], up[i])};
        a[dist[i]].push_back(vert);
    }
    for (int i = 0; i < h; ++i) {
        cout << a[i].size();
        for (auto[v, sz]: a[i])cout << ' ' << v + 1 << ' ' << sz;
        cout << '\n';
    }
    return 0;
}
/*
 11 14
 1 4
 1 8
 2 6
 4 3
 4 11
 5 2
 5 4
 5 7
 5 10
 7 6
 7 11
 8 3
 9 4
 10 6
 0
 */
