#define _CRT_SECURE_NO_WARNINGS
#define MOD 1000000000
#define INF 1000000007
#define cn const
#define push_back pb
#define ff first
#define ss second
#define sz size()
#define all(x) x.begin(), x.end()
#define sortall(x) sort(all(x))
#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <queue>
#include <string>
#include <deque>
#include <iomanip>
#include <map>
#include <set>
#include <cstdlib>
#define endl '\n'
using namespace std;
using ll = long long;
using ull = unsigned long long;
using pll = pair<ll, ll>;
using pii = pair<int, int>;
using vi = vector<int>;
using vl = vector<ll>;
using ld = long double;
using vs = vector<string>;
using vpii = vector<pii>;
template<typename T>
constexpr T sqr(const T& x)
{
    return x * x;
}
template<typename T>
bool rMin(T& v, const T& rval)
{
    if (rval < v)
    {
        v = rval;
        return true;
    }
    return false;
}
template<typename T>
bool rMax(T& v, const T& rval)
{
    if (v < rval)
    {
        v = rval;
        return true;
    }
    return false;
}


bool used[200002];
int dist[200002];

vi a[200002], b[200002], d[200002];
int maxDist = 0;

void bfs(vi start)
{
    queue<int> q;
    for (int i = 0; i < start.sz; i++)
    {
        q.push(start[i]);
        used[start[i]] = true;
        dist[start[i]] = 0;
    }

    while (!q.empty())
    {
        auto x = q.front();
        q.pop();
        d[dist[x]].pb(x);
        rMax(maxDist, dist[x]);

        for (int i = 0; i < a[x].sz; i++)
        {
            if (!used[a[x][i]])
            {
                used[a[x][i]] = true;
                dist[a[x][i]] = dist[x] + 1;
                q.push(a[x][i]);
            }
        }
    }
}

pii g[200002];

void solve()
{
    int n, m;

    cin >> n >> m;

    for (int i = 0; i < m; i++)
    {
        int u, v;

        cin >> u >> v;
    
        a[u].pb(v);
        b[v].pb(u);
    }

    vi c;

    for (int i = 1; i <= n; i++)
    {
        if (b[i].empty())
        {
            c.pb(i);
        }
    }

    bfs(c);

    for (int i = 0; i <= maxDist; i++)
    {
        sortall(d[i]);
    }

    int maxLength = 0;

    for (int i = 0; i <= maxDist; i++)
    {
        int curr = 0;
        for (int j = 0; j < d[i].sz; j++)
        {
            g[d[i][j]] = { curr, curr - 1 + max(a[d[i][j]].sz, b[d[i][j]].sz) };
            curr = g[d[i][j]].ss + 1;
        }
        rMax(maxLength, curr);
    }

    cout << maxDist + 1 << ' ' << maxLength << endl;

    for (int i = 0; i <= maxDist; i++)
    {
        cout << d[i].sz << ' ';

        for (int j = 0; j < d[i].sz - 1; j++)
        {
            cout << d[i][j] << ' ' << g[d[i][j]].ss - g[d[i][j]].ff + 1 << ' ';
        }

        cout << d[i].back() << ' ' << maxLength - 1 - g[d[i].back()].ff << endl;
    }
}


int main()
{
#ifdef _DEBUG
    freopen("Input.txt", "r", stdin);
#endif // _DEBUG

    ios::sync_with_stdio(false);
    cin.tie(0);
    int t = 1;
    //cin >> t;
    while (t--)
    {
        solve();
    }
#ifdef _DEBUG
    cin.get();
#endif // _DEBUG
    return 0;
}