/*
Hai mișcă-te tare, tare,
Dă-i motoare cu valoare!
 
Паля 200 цигари, газя като Ферари,
но пак не ще да ми мине,
цяла нощ не спирам да те мисля и боли ме
*/

#include <iostream>
#include <vector>
#include <cassert>
#include <algorithm>
#define int long long
using namespace std;
const int maxn = 2e5+10;
int n, m;
bool ordered;

vector < int > v[maxn];
vector < int > rev[maxn];
vector < int > rows[maxn];
int level[maxn], ap_size[maxn];
int length[maxn], position[maxn];

void find_level(int x) {

    for (int i : v[x]) {

        if (level[i]) continue;
        find_level(i);

    }

    if (v[x].empty()) level[x] = 1;
    else level[x] = level[v[x][0]] + 1;

}



void solve() {
    
    int max_level = 0;
    for (int i = 1 ; i <= n ; ++i) {

        sort(rev[i].begin(), rev[i].end());
        if (level[i]) continue;
        find_level(i);

    }

    for (int i = 1 ; i <= n ; ++i) {
    
        rows[level[i]].push_back(i);
        max_level = max(max_level, level[i]);

    }

    // cout << "initial apsize: \n";
    // for (int i = 1 ; i <= n ; ++i)
    //     cout << ap_size[i] << '\n';

    int subtract = 0, sum = 0;

    for (int inrow = 0 ; inrow < rows[1].size() ; ++inrow) {
        
        int curr_apsize = 0, curr = rows[1][inrow];
        for (int j = 0 ; j < rev[curr].size() - 1 ; ++j) {

            curr_apsize += ap_size[rev[curr][j]];

        }

        if (rev[curr].size() >= 2 || v[rev[curr].back()].back() == rows[1][inrow]) curr_apsize += subtract;
        if (v[rev[curr].back()].back() == rows[1][inrow]) {

            subtract = 0;
            curr_apsize += ap_size[rev[curr].back()];

        } else {

            subtract = min(-1ll, curr_apsize - ap_size[rows[1][inrow]]);
            curr_apsize++;

        }

        ap_size[rows[1][inrow]] = max(ap_size[rows[1][inrow]], curr_apsize);
        // cout << 1 << " ap size: " << rows[1][inrow] << " = " << ap_size[rows[1][inrow]] << '\n';

    }

    for (int i = 2 ; i <= max_level ; ++i) {

        subtract = 0;

        for (int inrow = 0 ; inrow < rows[i].size() ; ++inrow) {
        
            int curr_apsize = 0, curr = rows[i][inrow];
            for (int j = 0 ; j < v[curr].size() - 1 ; ++j) {

                curr_apsize += ap_size[v[curr][j]];

            }

            if (v[curr].size() >= 2 || rev[v[curr].back()].back() == rows[i][inrow]) curr_apsize += subtract;

            // cout << "initial apsize: " << subtract << ' ' << curr_apsize << ' ' << v[curr].size() << '\n';
        
            if (rev[v[curr].back()].back() == rows[i][inrow]) {

                // cout << "if: " << v[curr].back() << '\n';

                subtract = 0;
                curr_apsize += ap_size[v[curr].back()];

            } else {

                // cout << "else: " << curr_apsize << ' ' << ap_size[rows[i][inrow]] << '\n';
                 
                if (inrow != 0 && v[curr].back() == v[rows[i][inrow-1]].back()) subtract += min(-1ll, curr_apsize - ap_size[rows[i][inrow]]);
                else subtract = min(-1ll, curr_apsize - ap_size[rows[i][inrow]]);
                curr_apsize++;

            }

            ap_size[rows[i][inrow]] = max(ap_size[rows[i][inrow]], curr_apsize);
            // cout << i << " ap size: " << rows[i][inrow] << " = " << ap_size[rows[i][inrow]] << '\n';

        }

    }

    for (int i : rows[max_level])
        sum += ap_size[i];

    cout << max_level << ' ' << sum << '\n';
    for (int i = max_level ; i >= 1 ; --i) {
        
        cout << rows[i].size();
        for (int j : rows[i])
            cout << ' ' << j << ' ' << ap_size[j];
        cout << '\n';

    }

}

void fast_io() {

    ios_base :: sync_with_stdio(0);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cerr.tie(nullptr);

}

void read() {

    int x, y;
    cin >> n >> m;

    for (int i = 1 ; i <= m ; ++i) {

        cin >> x >> y;
        v[x].push_back(y);
        rev[y].push_back(x);
        ++ap_size[y];

    }

    cin >> ordered;
    assert(ordered);

}

signed main () {

    fast_io();
    read();
    solve();

    return 0;

}

/*
11 14
1 2
1 4
5 4
9 4
9 7
9 8
9 10
2 3
4 3
4 6
7 6
7 11
8 11
10 11
1
*/