/*
Hai mișcă-te tare, tare,
Dă-i motoare cu valoare!
 
Паля 200 цигари, газя като Ферари,
но пак не ще да ми мине,
цяла нощ не спирам да те мисля и боли ме
*/

#include <iostream>
#include <unordered_map>
using namespace std;

struct key {

    int pos;
    long long prod, sum;

    key() {

        pos = prod = sum = 0;

    }

    key(int _pos, long long _prod, long long _sum) {

        pos = _pos;
        prod = _prod;
        sum = _sum;

    }

};

long long inmap(key c) {

    return c.prod*(1e6+7) + c.sum*(1e5+7) + c.pos;

}

unordered_map < long long, long long > dp;
long long n, curr;

long long f(int pos, long long prod, long long sum, int last, int maxvalue) {

    // cout << "call: " << pos << ' ' << prod << ' ' << sum << ' ' << maxvalue << '\n';
    if (prod - sum == n - curr && pos == curr) return 1;
    if (pos == curr || prod - sum > n - pos || last == 1) return 0;
    if (dp.count(inmap({pos, prod, sum}))) return dp[inmap({pos, prod, sum})];
    long long ans = 0;
    ans += f(pos, prod, sum, last-1, maxvalue);
    ans += f(pos+1, prod*last, sum+last, last, maxvalue);

    // cout << "f: " << pos << ' ' << prod << ' ' << sum << " = " << ans << '\n';
    return dp[inmap({pos, prod, sum})] = ans;

}

long long power(int x, int base, int num) {

    if (base == 0) return 1;
    if (base & 1) return min((long long)num+1, x * power(x, base-1, num));
    long long res = power(x, base/2, num);
    return min(res*res, (long long)num+1);

}

void solve() {

    cin >> n;
    long long ans = 0;
    for (int i = 2 ; (1ll << i) <= 2*n && i <= n ; ++i) {

        dp.clear();
        curr = i;
        ans += f(0, 1, 0, 2*n, 2*n);

    }

    cout << ans << '\n';

}

signed main () {

    solve();
    return 0;

}