#include <bits/stdc++.h>

using namespace std;
const int maxn = 20, maxmask = (1 << 21);

int mod, dp[maxmask][maxn], n;
void solve()
{
    cin >> n >> mod;
    int high_mask = (1 << n);
    vector < pair < int, int > > v;
    for (int mask = 0; mask < high_mask; mask ++)
    {
        int cnt = 0, x = mask;
        while(x > 0)
        {
            if (x % 2 == 1)
                cnt ++;
            x /= 2;
        }
        v.push_back({cnt, mask});
    }

    sort(v.begin(), v.end());

    for (int bit = 0; bit < n; bit ++)
    {
        int mask = (1 << bit);
        dp[mask][bit] = 1;
    }

    for (int i = 0; i < v.size(); i ++)
    {
        int mask = v[i].second;

        for (int pos = 0; pos < n; pos ++)
        {
            if (dp[mask][pos] == 0)
                continue;
            for (int newpos = 0; newpos < n; newpos ++)
            {
                if ((mask & (1 << newpos)) != 0)
                    continue;
                if (newpos == pos + 1)
                    continue;

                int newmask = (mask ^ (1 << newpos));
                dp[newmask][newpos] += dp[mask][pos];
                if (dp[newmask][newpos] >= mod)
                    dp[newmask][newpos] -= mod;
            }
        }
    }

    int full_mask = (1 << n) - 1, ans;
    for (int i = 0; i < n; i ++)
    {
        ans += dp[full_mask][i];
        if (ans >= mod)
            ans -= mod;
    }
    int all = 1;
    for (int i = 1; i <= n; i ++)
        all = (all * i) % mod;

    cout << (all - ans + mod) % mod << endl;

}
int main()
{
    solve();
    return 0;
}
