#include <bits/stdc++.h>

using namespace std;
typedef unsigned long long ll;
const ll maxn = 20, maxmask = (1 << 21);

ll mod, dp[maxmask][maxn], n;
void solve()
{
    cin >> n >> mod;
    ll all = 1;
    for (ll i = 1; i <= n; i ++)
        all = (all * i) % mod;
    if (n > 16)
    {

        ll to_rem;
        if (n == 17)
            to_rem = (ll)(138547156531409) % mod;
        else if (n == 18)
            to_rem = (ll)(2486151753313617) % mod;
        else if (n == 19)
            to_rem = (ll)(47106033220679059) % mod;
        else
            to_rem = (ll)(939765362752547227) % mod;

        long long p1 = all;
        long long p2 = to_rem;
        cout << (p1 - p2 + mod) % mod << endl;
        return;
    }
    ll high_mask = (1 << n);
    vector < pair < ll, ll > > v;
    for (ll mask = 0; mask < high_mask; mask ++)
    {
        ll cnt = 0, x = mask;
        while(x > 0)
        {
            if (x % 2 == 1)
                cnt ++;
            x /= 2;
        }
        v.push_back({cnt, mask});
    }

    sort(v.begin(), v.end());

    for (ll bit = 0; bit < n; bit ++)
    {
        ll mask = (1 << bit);
        dp[mask][bit] = 1;
    }

       for (int i = 0; i < v.size(); i ++)
    {
        int mask = v[i].second;
        for (int pos = 0; pos < n; pos ++)
        {
            if (dp[mask][pos] == 0)
                continue;
            for (int newpos = 0; newpos < n; newpos ++)
            {
                if ((mask & (1 << newpos)) != 0)
                    continue;
                if (newpos == pos + 1)
                    continue;
                int newmask = (mask ^ (1 << newpos));
                dp[newmask][newpos] += dp[mask][pos];
                if (dp[newmask][newpos] >= mod)
                    dp[newmask][newpos] -= mod;
            }
        }
    }
    int full_mask = (1 << n) - 1, ans = 0;
    for (int i = 0; i < n; i ++)
    {
        ans += dp[full_mask][i];
        if (ans >= mod)
            ans -= mod;
    }
    int k = all;
    cout << (k - ans + mod) % mod << endl;

}
int main()
{
    solve();
    return 0;
}

/**
n = 20
939765362752547227
n = 19
47106033220679059
n = 18
2486151753313617
n = 17
138547156531409

*/
