#include <bits/stdc++.h>
using namespace std;
const int maxn = 15;
int n, m, deg[maxn], lvl[maxn], h, w, len[maxn], rowlen[maxn];
int used[maxn], p[maxn], tb[maxn][maxn], go_down[maxn][maxn], go_up[maxn][maxn];
vector < int > g[maxn], ng[maxn];
int cur_up[maxn][maxn], cur_down[maxn][maxn];
vector < int > row[maxn];
int tr;
void check()
{
    for (int i = 1; i <= h; i ++)
    {
        int last = 0;
        for (int j = 0; j < row[i].size(); j ++)
        {
            int v = p[row[i][j]];
            int lf = last + 1, rf = last + len[v];
            for (int p = lf; p <= rf; p ++)
                tb[i][p] = v;
            last = rf;
        }
    }
    for (int i = 1; i < h; i ++)
        for (int j = 1; j <= w; j ++)
        {
            cur_down[tb[i][j]][tb[i + 1][j]] = 1;
            cur_up[tb[i + 1][j]][tb[i][j]] = 1;
        }
    bool done = true;
    for (int i = 1; i <= n && done; i ++)
        for (int j = 1; j <= n && done; j ++)
        {
            if (cur_up[i][j] != go_up[i][j])
                done = false;
            if (cur_down[i][j] != go_down[i][j])
                done = false;
        }
    if (done)
    {
        cout << h << " " << w << endl;
        for (int i = 1; i <= h; i ++)
        {
            cout << row[i].size() << " ";
            for (int j = 0; j < row[i].size(); j ++)
            {
                int v = p[row[i][j]];
                cout << v << " " << len[v] << " ";
            }
            cout << endl;
        }
        exit(0);
    }
    for (int i = 1; i < h; i ++)
        for (int j = 1; j <= w; j ++)
        {
            cur_down[tb[i][j]][tb[i + 1][j]] = 0;
            cur_up[tb[i + 1][j]][tb[i][j]] = 0;
        }
}
void gen_len(int pos, int sum)
{
    if (pos == n + 1)
    {
        if (sum == h * w)
            check();
        return;
    }
    for (int i = 1; i <= w; i ++)
    {
        if (rowlen[lvl[pos]] + i <= w)
        {
            len[pos] = i;
            rowlen[lvl[pos]] += i;
            gen_len(pos + 1, sum + i);
            rowlen[lvl[pos]] -= i;
            len[pos] = 0;
        }
    }
}
void gen_perm(int x, int y)
{
    if (y == row[x].size())
        y = 0, x ++;
    if (x == h + 1)
    {
        gen_len(1, 0);
        return;
    }
    for (int j = 0; j < row[x].size(); j ++)
    {
        int v = row[x][j];
        if (used[v] == 1)
            continue;
        int u = row[x][y];
        p[u] = v;
        used[v] = 1;
        gen_perm(x, y + 1);
        used[v] = 0;
        p[u] = 0;
    }
}
void solve()
{
    cin >> n >> m ;
    for (int i = 1; i <= m; i ++)
    {
        int d, u;
        cin >> d >> u;
        g[d].push_back(u);
        go_down[d][u] = 1;
        go_up[u][d] = 1;
        deg[u] ++;
        ng[u].push_back(d);
    }
    cin >> tr;
    queue < int > q;
    for (int i = 1; i <= n; i ++)
    {
        if (deg[i] == 0)
            q.push(i), row[1].push_back(i), lvl[i] = 1;
    }
    while(!q.empty())
    {
        int cur = q.front();
        h = max(h, lvl[cur]);
        q.pop();
        for (int i = 0; i < g[cur].size(); i ++)
        {
            int u = g[cur][i];
            deg[u] --;
            if (deg[u] == 0)
            {
                q.push(u);
                lvl[u] = lvl[cur] + 1;
                row[lvl[u]].push_back(u);
            }
        }
    }
    for (int i = 1; i <= h; i ++)
        sort(row[i].begin(), row[i].end());
    int minw = 0;
    for (int i = 1; i <= h; i ++)
        minw = max(minw, (int)row[i].size());


    if (tr == 1)
    {

        for (int i = 1; i <= n; i ++)
            p[i] = i;
        for (w = minw; ; w ++)
        {
            gen_len(1, 0);
        }
    }
    else
    {        if (minw > 5 && h > 1)
            return;
        for (w = minw; ; w ++)
        {
            gen_perm(1, 0);
        }
    }
}
int main()
{
    solve();
    return 0;
}
/**
11 14
1 2
1 4
5 4
9 4
9 7
9 8
9 10
2 3
4 3
4 6
7 6
7 11
8 11
10 11
*/
