#include<iostream>
#include<vector>
#include<queue>
using namespace std;
#define ll long long
#define MAXN 200007
vector <ll> deca[MAXN];
vector <ll> bashti[MAXN];
vector <ll> niva[MAXN];
ll brdeca[MAXN];
ll nivo[MAXN];
ll brNiva=1;
bool used[MAXN];
bool podredeniLiSa;
void bfs(int vr) {
    nivo[vr]=1;
    queue <int> op;
    op.push(vr);
    while(!op.empty()){
        vr=op.front();
        op.pop();
        for(auto to : deca[vr]){
            //cout<<"gledam decata na "<<vr<<" i sym na dete "<<to;
            if(!used[to]){
                used[to]=true;
                nivo[to]=nivo[vr]+1;
                if(nivo[to]>brNiva) brNiva=nivo[to];
                op.push(to);
            }
        }
    }

}
int main() {
    ll N,m;
    int x,y;
    cin>>N>>m;
    for(int i = 0 ; i < m ; i ++) {
        cin>>x>>y;
        deca[x].push_back(y);
        bashti[y].push_back(x);
    }
    cin>>podredeniLiSa;
    for(int i = 1 ; i <= N ; i ++ ) {
        brdeca[i]=deca[i].size();
        while(bashti[i].size()>deca[i].size() and deca[i].size()!=0){
            //cout<<"vruh "<<i<<" ima mn bashti\n";
            bashti[deca[i][0]].push_back(i);
            deca[i].push_back(deca[i][0]);
        }
    }

    for(int i=1;i<=N;i++){
        if(bashti[i].empty()){
            bfs(i);
        }
    }
    ///systavqne na spisyk s vyrhovete na vsqko nivo
    for(int i = 1 ; i<=N;i++){
        niva[nivo[i]].push_back(i);

        //cout<<bashti[i].size()<<" "<<deca[i].size()<<"\n";
    }
    ///namirane na shirochina na reda
    ll shirochina=0;
        for(auto p:niva[brNiva]){
            shirochina+=max(deca[p].size(),bashti[p].size());
        }
    cout<<brNiva<<" "<<shirochina<<"\n";
    for(int i = 1 ; i <= brNiva ; i++) {
        cout<<niva[i].size()<<" ";
        for(auto p:niva[i]){
            cout<<p<<" "<<max(deca[p].size(),bashti[p].size())<<" ";
        }
        cout<<"\n";
    }
    return 0;
}
