#include <bits/stdc++.h>
using namespace std;

const int maxn = 2*1e5+2;
int n, m, used[maxn], pr[maxn], sz, ans[maxn], max_lvl, ans_lvl[maxn], max_ans;
vector <int> in[maxn], out[maxn], lvl[maxn];

void read()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin >> n >> m ;
    int i, x, y;
    for (i=1; i<=m; ++i)
    {
        cin >> x >> y ;
        used[y] = 1;
        in[y].push_back(x);
        out[x].push_back(y);
    }
}

void BFS()
{
    queue <int> q;
    //memset(used, 0, sizeof(used));
    int i;
    for (i=1; i<=n; ++i)
    {
        if (used[i] == 0)
        {
            q.push(i);
            used[i] = 1;
            lvl[1].push_back(i);
            pr[(++sz)] = i;
        }
        else used[i] = 0;
    }

    int w, nb, len;
    while (!q.empty())
    {
        w = q.front(); q.pop();
        len = out[w].size();
        for (i=0; i<len; ++i)
        {
            nb = out[w][i];
            if (used[nb] == 0)
            {
                used[nb] = used[w]+1;
                lvl[used[nb]].push_back(nb);
                pr[(++sz)] = nb;
                max_lvl = used[nb];
                q.push(nb);
            }
        }
    }
}

void solve()
{
    BFS();
    int i, p1, p2, v, r, j, k, l;
    for (i=1; i<=n; ++i)
    {
        v = pr[i];
        cout << v << " " << used[v] << endl;
        p1 = in[v].size();
        p2 = out[v].size();
        ans[v] += (p1 < p2 ? p2 : p1);
        cout << p1 << " " << p2 << " " << ans[v] << endl;
        if (p1!= 0 && p1 < p2)
        {
            r = p2-p1;
            j = v;
            while (true)
            {
                l = in[j].size();
                if (l == 0) break;
                k = in[j][l-1];
                ans[k] += r;
                j = k;
            }

            j = v;
            while (true)
            {
                l = out[j].size();
                if (l == 0) break;
                k = out[j][l-1];
                ans[k] += r;
                j = k;
            }
        }
    }
}

void new_solve()
{
    BFS();
    int i, p1, p2, v;
    for (i=1; i<=sz; ++i)
    {
        v = pr[i];
        p1 = in[v].size();
        p2 = out[v].size();
        ans[v] = max(p1 , p2);
        ans_lvl[used[v]] += ans[v];
        if (ans_lvl[used[v]] > max_ans) max_ans = ans_lvl[used[v]];
    }

    int len;
    for (i=1; i<=max_lvl; ++i) if (ans_lvl[i] != max_ans) ans[lvl[i].size()-1] += (max_ans-ans_lvl[i]);
}

int sum()
{
    int i, len = lvl[max_lvl].size(), s = 0;
    for (i=0; i<len; ++i) s += ans[lvl[max_lvl][i]];
    return s;
}

void print()
{
    cout << max_lvl << " " << max_ans << '\n' ;
    int i, j, len;
    for (i=1; i<=max_lvl; ++i)
    {
        len = lvl[i].size();
        cout << len << " " ;
        for (j=0; j<len; ++j)
        {
            cout << lvl[i][j] << " " << ans[lvl[i][j]] << " " ;
        }
        cout << '\n' ;
    }
}


int main()
{
    read();
    new_solve();
    print();
    return 0;
}

/*
11 14
1 4
1 5
2 5
3 5
3 6
3 7
3 8
4 9
5 9
5 10
6 10
6 11
7 11
8 10
*/